;
; les procdures
;


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gnration de nombres alatoires
; *
; * note : ici je n'ai pas utilis les valeurs que j'utilise habituellement, parcequ'elles font partie de ma
; * signature (et vous ne voudriez pas vous retrouver avec un procs sur le dos, non ?) alors j'en ai mis d'autres
; * qui devrait fonctionner...
; * si ce n'est pas le cas changez les... le systme employ permet un grand ventail de possibilits
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
;
; ici, ce sont les tmoins concernant les informations du microprocesseur
;

Temoins_Aptitudes_Du_MicroProcesseur	DWORD ?
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
; bit 12 =


.CODE
ALIGN 16
;
; obtenir des informations sur le microprocesseur qui utilise le programme
;
; Rceptionne :
; rien
;
; Retourne :
; la variable Temoins_Aptitudes_Du_MicroProcesseur est dfinie avec les bits positionns
;
; Syntaxe : DefinirAptitudesDuProcesseur
;
DefinirAptitudesDuProcesseur PROC
		pushad									;; empiler tous les registres

		mov Temoins_Aptitudes_Du_MicroProcesseur,0		;; mise  0 de la variable
; l'instruction CPUID est supporte, seulement s'il est possible de positionner/enlever le flag ID (EFLAGS bit 21).
		pushfd									;; ) copier les flags+flags etendus dans eax et edx
		pop eax									;; )
		mov edx,eax								;; )
		xor eax,200000h							;; inverser le flag ID
		push eax									;; ) et recopier le rsultat dans les flags
		popfd									;; )
		pushfd									;;	) puis on recopie  nouveau les flags dans eax
		pop eax									;;	)
		cmp eax,edx								;; comparer le rsultat  notre prcdente sauvegarde
		je PasSupportCpuid							;; si c'est semblable, c'est que notre modif n'a eu aucun effet, alors aller PasSupportCpuid
		mov Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000001b	;; positionner le bit correspondant dans notre variable

; ici, l'instruction cpuid est supporte, on va donc s'en servir pour connaitre les aptitudes du processeur
;		mov eax,0									;; ici, on dtermine le type d'infos que l'on veut rcuprer
;		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
;												;; (eax contient le nombre d'entres cpuid maximales)

; ici, on passe aux informations suivantes
		mov eax,1									;; ici, on dtermine les infos les plus importantes (du moins pour la programmation)
		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
												;; (eax contient le type, le model,la famille,...)
												;; (edx contient les caractristiques disponibles)
; les instructions fpu sont disponibles ?
		bt edx,0									;; tester le bit 0
		jnc PasSupportFpu							;; si le flag carry n'est pas positionn, aller PasSupportFpu
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000010b	;; positionner le bit correspondant dans notre variable
PasSupportFpu:
; l'instruction rdtsc est disponible ?
		bt edx,4									;; tester le bit 4
		jnc PasSupportRdtsc							;; si le flag carry n'est pas positionn, aller PasSupportRdtsc
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000100b	;; positionner le bit correspondant dans notre variable
PasSupportRdtsc:
; l'instruction CmpXchg8b est disponible ?
		bt edx,8									;; tester le bit 8
		jnc PasSupportCmpXchg8b						;; si le flag carry n'est pas positionn, aller PasSupportCmpXchg8b
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000001000b	;; positionner le bit correspondant dans notre variable
PasSupportCmpXchg8b:
; les instructions cmov sont disponibles ?
		bt edx,15									;; tester le bit 15
		jnc PasSupportCmov							;; si le flag carry n'est pas positionn, aller PasSupportCmov
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000010000b	;; positionner le bit correspondant dans notre variable
PasSupportCmov:
; les instructions clfsh sont disponibles ?
		bt edx,19									;; tester le bit 19
		jnc PasSupportClfsh							;; si le flag carry n'est pas positionn, aller PasSupportClfsh
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000100000b	;; positionner le bit correspondant dans notre variable
PasSupportClfsh:
; les instructions mmx sont disponibles ?
		bt edx,23									;; tester le bit 23
		jnc PasSupportMmx							;; si le flag carry n'est pas positionn, aller PasSupportMmx
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000001000000b	;; positionner le bit correspondant dans notre variable
PasSupportMmx:
; les instructions fxsr sont disponibles ?
		bt edx,24									;; tester le bit 24
		jnc PasSupportFxsr							;; si le flag carry n'est pas positionn, aller PasSupportFxsr
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000010000000b	;; positionner le bit correspondant dans notre variable
PasSupportFxsr:
; les instructions sse sont disponibles ?
		bt edx,25									;; tester le bit 25
		jnc PasSupportSse							;; si le flag carry n'est pas positionn, aller PasSupportSse
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000100000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse:
; les instructions sse2 sont disponibles ?
		bt edx,26									;; tester le bit 26
		jnc PasSupportSse2							;; si le flag carry n'est pas positionn, aller PasSupportSse2
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000001000000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse2:
; les instructions htt sont disponibles ?
		bt edx,28									;; tester le bit 28
		jnc PasSupportHtt							;; si le flag carry n'est pas positionn, aller PasSupportHtt
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000010000000000b	;; positionner le bit correspondant dans notre variable
PasSupportHtt:
; les instructions sse3 sont disponibles ?
		bt ecx,0									;; tester le bit 0
		jnc PasSupportSse3							;; si le flag carry n'est pas positionn, aller PasSupportSse3
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000100000000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse3:
;; les instructions Xxx sont disponibles ?
;		bt edx,Xxx								;; tester le bit 
;		jnc PasSupportXxx							;; si le flag carry n'est pas positionn, aller
;		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000001000000000000b	;; positionner le bit correspondant dans notre variable
;PasSupportXxx:

; ici, on passe aux informations suivantes
;		mov eax,2									;; ici, on dtermine les infos concernant le cache
;		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
PasSupportCpuid:
		popad									;; dsempiler tous les registres
	ret											;; retourner, sortir de la procdure
DefinirAptitudesDuProcesseur ENDP


.DATA
ALIGN 16
_Nombres_Aleatoires_		DWORD ?
.CODE
ALIGN 16
;
; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.
;
; Rceptionne :
; rien
;
; Retourne:
; eax = nombre de tick depuis le dmarrage de l'ordi. (mais surtout, la variable _Nombres_Aleatoires_ est dfinie)
;
; syntaxe : InitialiserNombresAleatoires
;
InitialiserNombresAleatoires PROC
		invoke GetTickCount							;; obtenir les millisecondes depuis le dmarrage
		test eax,eax								;; tester si eax = 0 (si c'est possible ! si vous lancez ce programme 48 jours aprs le dmarrage de l'ordinateur, lol)
		jnz Label1								;; si diffrent aller Label 1
		mov eax,123456789							;; mettre un nombre quelconque (pour eviter une division ultrieure par 0, suivant le gnrateur utilis)
Label1:	mov _Nombres_Aleatoires_,eax					;; sauver le rsultat pour initialiser les nombres alatoires
	ret											;; retourner (sortir de la procdure)
InitialiserNombresAleatoires ENDP


ALIGN 16
;
; generer un nombre aleatoire 32-bits entre 0 et une valeur maximale (exclue)
;
; Rceptionne :
; ebx = la valeur maximale +1 (ne peut pas tre zro, doit imprativement tre suprieur  1 pour une valeur
; situe dans un rang, ou 1 pour gnrer une valeur alatoire 32 bits)
;
; Retourne :
; eax = nombre aleatoire entre 0 et la valeur maximale (exclue), ou un nombre alatoire 32 bits si ebx = 1
;
; syntaxe : GenererNombreAleatoire
;
GenererNombreAleatoire PROC
		push edx									;; empiler edx

		mov eax,987654321							;; placer 987654321 dans eax
		mul _Nombres_Aleatoires_						;; multiplier eax par l'alatoire prcedent
		bswap eax									;; inverser l'ordre des octets pour rendre la valeur plus alatoire
		xor eax,078787878h							;; et pratiquer une inversion de bits (ne peut tre fait avec 0h ou FFFFFFFFh)
		jnz Label1								;; si c'est diffrent de 0, aller Label1
		mov eax,123456789							;; sinon, placer 123456789 dans eax
Label1:	mov _Nombres_Aleatoires_,eax					;; sauvegarder le nouveau nombre alatoire pour la gnration du prochain
; ici, on teste si c'est le cas d'une valeur alatoire 32 bits 
		cmp ebx,1									;; comparer ebx  1
		je Label2									;; si c'est le cas, c'est une valeur alatoire 32 bits, alors aller Label2
; ici, on traite le cas d'une valeur comprise entre 0 et X-1
		mul ebx									;; multiplier ensuite le nombre alatoire par la valeur maximale
		mov eax,edx								;; et placer le dpassement en eax
Label2:
		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)
GenererNombreAleatoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine d'agrandissement * 2
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; agrandir un cran (en multipliant sa taille par 2, avec un remplissage par fondu, sauf pour la dernire ligne) en version SSE
; l'cran originel doit tre multiple de 4 car les pixels sont, ici, traits par quatre
; videment, les deux blocs mmoire doivent avoir les tailles correspondantes... et doivent tre aligns sur 16 octets
;
; Rceptionne :
; esi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel
; edi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'ecran de destination
;
; retourne :
; rien
;
; syntaxe : Mmx_AgrandirX2_RemplissageFondu
;
Mmx_AgrandirX2_RemplissageFondu PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran originel dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut de la zone originelle dans esi
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut de la zone de destination dans edi
		neg ebx									;; on inverse ebx, qui sera notre compteur de boucle pour les lignes
		pxor MM7,MM7								;; effacer MM7
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
Label0:	lea edx,[edi+ebp]							;; edx = _Pointeur_ + _Largeur_Ecran_X4_
		lea edi,[edi+2*ebp]							;; edi = _Pointeur_ + _Largeur_Ecran_X4_*2
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, on traite la premire ligne (que l'on va doubler)
		movd MM0,DWORD PTR [ecx+esi]					;; placer la premire couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
Label1:	movd MM1,DWORD PTR [ecx+esi]					;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		psrlw MM0,1								;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM1							;; compacter les words de MM0 et MM1 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq QWORD PTR [2*ecx+edx],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
		add ecx,4									;; augmenter ecx d'1 dword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
		add edi,ebp								;; ajouter _Largeur_Ecran_Destination_X4_ au pointeur destination (puisqu'un ajout  dja t fait)
		inc ebx									;; incrmener ebx d'une ligne
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )

; maintenant que la premire ligne a t calcule, on va pouvoir calculer les lignes intermediaires en plus...
Label2:	mov eax,edi								;; copier edi dans eax
		mov edx,edi								;; copier edi dans edx
		sub eax,ebp								;; enlever une ligne destination  eax
		add edi,ebp								;; ajouter une ligne destination  edi
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes

; ici, on traite les lignes
		movd MM0,DWORD PTR [ecx+esi]					;; placer la premire couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
Label3:	movd MM1,DWORD PTR [ecx+esi]					;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		psrlw MM0,1								;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		movq MM2,MM0								;; faire une copie de MM0 en MM2 (qui servira pour les lignes intermdiaires)
		packuswb MM0,MM1							;; compacter les words de MM0 et MM1 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0

; ici, on traite les lignes intermediaires
		movq MM3,QWORD PTR [2*ecx+eax]				;; placer le qword de 2 lignes avant dans MM3
		movq MM4,MM3								;; recopier MM3 dans MM4
		punpcklbw MM3,MM7							;; placer 00XX00XX00XX00XX dans MM3
		punpckhbw MM4,MM7							;; placer 00XX00XX00XX00XX dans MM4
		paddw MM3,MM2								;; ajouter en parallle MM2  MM3
		paddw MM4,MM1								;; ajouter en parallle MM1  MM4
		psrlw MM3,1								;; diviser en parallle les words en MM3 par 2 (par un dcalage  droite de 2 bits)
		psrlw MM4,1								;; diviser en parallle les words en MM4 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM3,MM4							;; compacter les words de MM3 et MM4 en octets dans MM3
		movq QWORD PTR [2*ecx+edx],MM3				;; et recopier les deux couleurs casses dans edx+(ecx*2) (la ligne prcdente)
Label4:	add ecx,4									;; augmenter ecx d'1 dword
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
		add edi,ebp								;; ajouter _Largeur_Ecran_Destination_X4_ au pointeur destination (puisqu'un ajout  dja t fait)
		inc ebx									;; incrmener ebx d'une ligne
		jnz Label2								;; tant que ebx est diffrent de 0, aller Label2

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AgrandirX2_RemplissageFondu ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine d'effacement d'un bloc mmoire
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; effacer un bloc memoire (en le remplissant de 0)
; note : MM0 est modifi
;
; Syntaxe :
; mov eax,{taille  ffacer en octets}
; mov edi,{adresse du bloc de destination}
; call Mmx_EffacerBlocMemoire
;
; Retourne :
; rien
;
Mmx_EffacerBlocMemoire PROC
		push ecx									;; empiler ecx

; ici on traite les 4x owords
		mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label1									;; si ecx est gal  0, aller Label1
		add edi,ecx								;; on ajoute ecx  edi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer MM0
Label0:	movq QWORD PTR[edi+ecx],MM0					;; placer 0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM0					;; placer 0 en edi+ecx+8
		movq QWORD PTR[edi+ecx+16],MM0				;; placer 0 en edi+ecx+16
		movq QWORD PTR[edi+ecx+24],MM0				;; placer 0 en edi+ecx+24
		movq QWORD PTR[edi+ecx+32],MM0				;; placer 0 en edi+ecx+32
		movq QWORD PTR[edi+ecx+40],MM0				;; placer 0 en edi+ecx+40
		movq QWORD PTR[edi+ecx+48],MM0				;; placer 0 en edi+ecx+48
		movq QWORD PTR[edi+ecx+56],MM0				;; placer 0 en edi+ecx+56
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label0								;; tant que ecx est diffrent de 0, aller Label0

; ici on traite les owords
Label1:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label3									;; si ecx est gal  0, aller Label3
		add edi,ecx								;; on ajoute ecx  edi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer MM0
Label2:	movq QWORD PTR[edi+ecx],MM0					;; placer 0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM0					;; placer 0 en edi+ecx+8
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label2								;; tant que ecx est diffrent de 0, aller Label2

; ici on traite les dwords
Label3:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label5									;; si ecx est gal  0, aller Label5
		add edi,ecx								;; on ajoute ecx  edi
		neg ecx									;; inverser ecx
Label4:	mov DWORD PTR [edi+ecx],0					;; placer 0 en edi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label4								;; tant que ecx est diffrent de 0, aller Label4

; ici on traite les octets
Label5:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b		;; ne conserver que les bits octets en ecx
		jz Label7									;; si ecx est gal  0, aller Label7
		add edi,ecx								;; on ajoute ecx  edi
		neg ecx									;; inverser ecx
Label6:	mov BYTE PTR [edi+ecx],0						;; placer 0 en edi+ecx
		inc ecx									;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label6								;; tant que ecx est diffrent de 0, aller Label6
Label7:	sub edi,eax								;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_EffacerBlocMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine d'effet fondu
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; crer un effet blur montant sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduAscendant
;
Mmx_EffetFonduAscendant PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)

; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM3,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM3
		movd MM2,DWORD PTR [esi]						;; placer le dword en esi dans MM2
		punpcklbw MM3,MM7							;; entrelacer les octets suprieurs de MM3 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets suprieurs de MM2 et MM7

; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		add esi,eax								;; on ajoute le rsultat  esi
		mov edi,esi								;; copier esi dans edi
		add edi,eax								;; ajouter _Largeur_Ecran_X4_  edi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter

; ici, commence la boucle pour une ligne
Label2:	movd MM1,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM1
		movd MM0,DWORD PTR [edi+ecx]					;; placer le dword en esi dans MM0
		punpcklbw MM1,MM7							;; entrelacer les octets infrieurs de MM1 et MM7
		punpcklbw MM0,MM7							;; entrelacer les octets infrieurs de MM0 et MM7
; faire la somme des valeurs
		paddw MM0,MM3								;; ajouter en parallle MM3  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
; transfert de donnes pour eviter de les relire et de refaire des entrelacements
		movq MM3,MM2								;; on transfert MM2 dans MM3
		movq MM2,MM1								;; on transfert MM1 dans MM2
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduAscendant ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gestion mmoire/crans (c'est relativement la mme chose...)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; allouer un cran (bloc mmoire)  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = largeur de l'cran (en pixels)
; ebx = hauteur de l'cran (en pixels)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (ce sera le tampon de l'cran)
;
; retourne :
; eax = adresse du bloc mmoire align
; et les variables x._Pointeur_, x._Pointeur_A_Liberer_, x._Taille_Du_Bloc_, x._Largeur_Ecran_, x.Hauteur_Ecran_,
; et x._Largeur_Ecran_X4_ sont dfinies
;
; syntaxe : CreerEcran
;
CreerEcran PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_,eax	;; placer eax dans x._Largeur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,ebx	;; placer eax dans x._Hauteur_Ecran_
		shl eax,2									;; multiplier la largeur par 4
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_,eax	;; placer eax dans x._Largeur_Ecran_X4_
		mul ebx									;; multiplier _Largeur_Ecran_X4_ par _Hauteur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,16								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Zbuffer_,eax	;; sauvegarder eax dans x._Pointeur_Zbuffer_ (ca vite des dsagrments de mauvaise utilisation CreerEcran/CreerEcranAvecZBuffer)

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
CreerEcran ENDP


ALIGN 16
;
; crer l'instance mmoire (ce qui doit tre fait, une fois, avant de pouvoir allouer des blocs mmoires)
; note : normalement (sauf cas exceptionnels) une seule instance suffit pour l'ensemble de votre programme
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; eax = l'adresse de l'instance
; et les variables x._Instance_, x._Taille_Initiale_ et x._Taille_Maximale_ sont dfinies
;
; syntaxe : CreerInstanceMemoire
;
CreerInstanceMemoire PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(_Informations_Memoire_ PTR [esi])._Taille_Initiale_,(_Informations_Memoire_ PTR [esi])._Taille_Maximale_	;; cr une instance mmoire, et defini des valeurs mmoire
		mov (_Informations_Memoire_ PTR [esi])._Instance_,eax	;; sauvegarde du pointeur de l'instance

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
CreerInstanceMemoire ENDP


ALIGN 16
;
; librer un cran (bloc mmoire)
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_
;
; retourne :
; rien
;
; syntaxe : SupprimerEcran
;
SupprimerEcran PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerEcran ENDP


ALIGN 16
;
; supprimer l'instance mmoire (ce qui doit tre fait avant de sortir de l'application, si une instance  t cre)
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; rien
;
; syntaxe : SupprimerInstanceMemoire
;
SupprimerInstanceMemoire PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapDestroy,(_Informations_Memoire_ PTR [esi])._Instance_	;; librer l'instance mmoire

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerInstanceMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de redimensionnement (autre que *2)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Largeur_Ecran_			DWORD ?
_Hauteur_Ecran_			DWORD ?
_Largeur_Ecran_Originel_		DWORD ?
_Hauteur_Ecran_Originel_		DWORD ?
.CODE
ALIGN 16
;
; crer et dfinir une table, pour retailler (changer l'echelle, pour eviter des multiplications et
; divisions multiples pendant le redimensionnement)
; note : ne pas oublier de supprimer la table de redimensionnement prcdente (s'il y en a une)
; avant d'en crer une nouvelle (le cumul injustifi causera un crash)
; et videment, il faut s'assurer qu'une instance mmoire a t cre
;
; Rceptionne :
; eax = largeur de l'cran que l'on veut obtenir (en pixels) (la largeur obtenue par DefinirTailleDeRedimensionnement si ca doit tre proportionnel)
; ebx = hauteur de l'cran que l'on veut obtenir (en pixels) (la hauteur obtenue par DefinirTailleDeRedimensionnement si ca doit tre proportionnel)
; ecx = largeur de l'cran originel (en pixels)
; edx = hauteur de l'cran originel (en pixels)
; esi = adresse (offset) d'une structure _Informations_Memoire_ (parcequ'on en a besoin)
; edi = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
;
; Retourne :
; rien
;
; syntaxe : DefinirTableDeRedimensionnement
;
DefinirTableDeRedimensionnement PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde les entres, ca va reservir...
		mov _Largeur_Ecran_,eax						;; sauvegarder eax dans _Largeur_Ecran_
		mov _Hauteur_Ecran_,ebx						;; sauvegarder ebx dans _Hauteur_Ecran_
		mov _Largeur_Ecran_Originel_,ecx				;; sauvegarder ecx dans _Largeur_Ecran_Originel_
		mov _Hauteur_Ecran_Originel_,edx				;; sauvegarder edx dans _Hauteur_Ecran_Originel_
; puis on calcul la taille mmoire  allouer...
		shl eax,2									;; multiplier _Largeur_Ecran_ par 4 (1 dword)
		mul ebx									;; multiplier _Largeur_Ecran_*DWORD par _Hauteur_Ecran_
		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,16								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
; on alloue l'espace mmoire (qui est en fait gal  la taille cran) pour la table ( ce sera la zone de substitution de valeur)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
; maintenant on va remplir chaque valeur de la premire ligne de notre table de substitution par la position relative dans l'cran originel
		mov esi,eax								;; copier _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_ dans esi
		mov ebx,_Largeur_Ecran_						;; placer _Largeur_Ecran_ dans ebx
		xor ecx,ecx								;; effacer ecx
; ici, on calcule les valeurs de substitution de la largeur
Label1:	mov eax,ecx								;; copier ecx dans eax
		mul _Largeur_Ecran_Originel_					;; multiplier eax par _Largeur_Ecran_Originel_
		xor edx,edx								;; effacer edx (ncessaire pour la division qui suit)
		div ebx									;; diviser eax par _Largeur_Ecran_
		shl eax,2									;; multiplier le rsultat obtenu par 4 (parceque ca devra tre un dword)
		mov DWORD PTR [4*ecx+esi],eax					;; sauver le rsultat obtenu  l'adresse en _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_+(ecx*4)
		inc ecx									;; incrmenter le pas de boucle
		cmp ecx,ebx								;; comparer ecx  _Largeur_Ecran_
		jb Label1									;; tant que ecx est infrieur  _Largeur_Ecran_, aller Label1
; ici, la premire ligne est calcule, on va la recopier dans toutes les autres lignes
		shl ebx,2									;; multiplier ebx par 4
		mov edi,esi								;; recopier l'adresse en esi dans edi
		add edi,ebx								;; ajouter l'uivalent d'une ligne  edi
		mov eax,_Hauteur_Ecran_						;; placer _Hauteur_Ecran_ (le nombre de lignes) dans eax
		dec eax									;; enlever une ligne  eax (ben oui, on en a dja calcul une...)
		neg eax									;; inverser eax
; ici on traite les owords
Label2:	mov ecx,ebx								;; copier _Largeur_Ecran_ x4 dans ecx
		and ecx,11111111111111111111111111110000b		;; ne conserver que les bits owords en ecx
		jz Label4									;; si ecx est gal  0, aller Label4
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label3:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR [edi+ecx],edx					;; placer le dword en edi+ecx
		mov edx,DWORD PTR [esi+ecx+4]					;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR [edi+ecx+4],edx					;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR [esi+ecx+8]					;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR [edi+ecx+8],edx					;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR [esi+ecx+12]				;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR [edi+ecx+12],edx				;; placer le dword en edi+ecx+12
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
; ici on traite les dwords
Label4:	mov ecx,ebx								;; copier _Largeur_Ecran_ x4 dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label6									;; si ecx est gal  0, aller Label6
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label5:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et le recopier en edi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label5								;; tant que ecx est sign, aller Label5
; ici on ne traite pas les octets (car au minimum ce sont des dwords)
Label6:	sub esi,ebx								;; soustraire la ligne copie  esi (pour retrouver l'adresse originelle)
		inc eax									;; incrmenter eax
		jnz Label2								;; tant que eax est diffrent de 0, aller Label2
; ici, notre table est remplie de premires ligne, on initialise la boucle pour la hauteur
		xor ecx,ecx								;; mettre ecx  0
; ici, on calcule les valeurs de substitution de la hauteur
Label7:	mov eax,ecx								;; copier ecx dans eax
		mul _Hauteur_Ecran_Originel_					;; multiplier eax par _Hauteur_Ecran_Originel_
		xor edx,edx								;; effacer edx (ncessaire pour la division qui suit)
		div _Hauteur_Ecran_							;; diviser eax par _Hauteur_Ecran_
		mul _Largeur_Ecran_Originel_					;; multiplier le rsultat en eax par une largeur de ligne
		shl eax,2									;; on multiplie eax par 4 (comme ca on a multipli par Largeur de ligne x4)
; ici, la hauteur est dfinie, on l'ajoute sur toutes les valeurs de la ligne, on traite les owords
		mov edi,ebx								;; copier _Largeur_Ecran_ x4 dans edi
		and edi,11111111111111111111111111110000b		;; ne conserver que les bits owords en edi
		jz Label9									;; si edi est gal  0, aller Label9
		add esi,edi								;; on ajoute edi  esi
		neg edi									;; inverser edi
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label8:	add DWORD PTR [esi+edi],eax					;; placer le dword en esi+edi
		add DWORD PTR [esi+edi+4],eax					;; placer le dword en esi+edi+4
		add DWORD PTR [esi+edi+8],eax					;; placer le dword en esi+edi+8
		add DWORD PTR [esi+edi+12],eax				;; placer le dword en esi+edi+12
		add edi,16								;; on ajoute 16  edi (notre pas de boucle)
		jnz Label8								;; tant que edi est diffrent de 0, aller Label8
; ici on traite les dwords
Label9:	mov edi,ebx								;; copier _Largeur_Ecran_ x4 dans edi
		and edi,00000000000000000000000000001100b		;; ne conserver que les bits dwords en edi
		jz Label11								;; si edi est gal  0, aller Label11
		add esi,edi								;; on ajoute edi  esi
		neg edi									;; inverser edi
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label10:	add DWORD PTR [esi+edi],eax					;; placer le dword en esi+edi
		add edi,4									;; on ajoute 4  edi (notre pas de boucle)
		jnz Label10								;; tant que edi est sign, aller Label10
; ici on ne traite pas les octets (car au minimum ce sont des dwords)
Label11:	inc ecx									;; incrmenter le pas de boucle
		cmp ecx,_Hauteur_Ecran_						;; comparer ecx  _Hauteur_Ecran_
		jb Label7									;; tant que ecx est infrieur  _Hauteur_Ecran_, aller Label7

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
DefinirTableDeRedimensionnement ENDP


ALIGN 16
;
; retailler un cran (en fait on va substituer des valeurs  d'autres, pour eviter des multiplications et divisions multiples)
; videment, une table doit, au pralable, avoir t dfinie par DefinirTableDeRedimensionnement
;
; Rceptionne :
; eax = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
; esi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de l'cran originel)
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de l'cran final)
;
;
; Retourne :
; rien
;
; syntaxe : Redimensionner
;
Redimensionner PROC
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov ebx,(_Bloc_Memoire_ PTR [eax])._Pointeur_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_ dans ebx
; ici, on traite les owords
		mov ecx,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ dans ecx
		and ecx,11111111111111111111111111110000b		;; ne conserver que les bits owords en ecx
		jz Label2									;; si ecx est gal  0, aller Label2
		add ebx,ecx								;; ajouter la taille au pointeur de la table
		add edi,ecx								;; ajouter la taille au pointeur destination
		neg ecx									;; inverser ecx
		nop										;; ) alignement ncessaire pour un meilleur rendement
Label1:	mov edx,DWORD PTR [ebx+ecx]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et la recopier dans edi+ecx 
		mov edx,DWORD PTR [ebx+ecx+4]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+4],edx					;; et la recopier dans edi+ecx+4
		mov edx,DWORD PTR [ebx+ecx+8]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+8],edx					;; et la recopier dans edi+ecx+8
		mov edx,DWORD PTR [ebx+ecx+12]				;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+12],edx				;; et la recopier dans edi+ecx+12
		add ecx,16								;; augmenter ecx d'1 oword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
; ici, on traite les dwords
Label2:	mov ecx,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits owords en ecx
		jz Label4									;; si ecx est gal  0, aller Label4
		add ebx,ecx								;; ajouter la taille au pointeur de la table
		add edi,ecx								;; ajouter la taille au pointeur destination
		neg ecx									;; inverser ecx
Label3:	mov edx,DWORD PTR [ebx+ecx]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et la recopier dans edi+ecx 
		add ecx,4									;; augmenter ecx d'1 dword
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
; on ne traite pas les octets car il ne peut y avoir que des dwords (alpha,rouge,vert,bleu) au minimum
Label4:	sub edi,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; soustraire _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ au pointeur destination (pour retrouver l'adresse originelle)

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)
Redimensionner ENDP


ALIGN 16
;
; supprimer une table de retaillage
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
;
; Retourne :
; rien
;
; syntaxe : SupprimerTableDeRedimensionnement
;
SupprimerTableDeRedimensionnement PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerTableDeRedimensionnement ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines Sprites
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Sprite_Boucle_Largeur_			DWORD ?,?,?,?			;; (align 16)
_Sprite_Boucle_Hauteur_			DWORD ?,?,?,?			;; (align 16)
_Sprite_Complement_Largeur_X4_	DWORD ?,?,?,?			;; (align 16)
; note : ici, toutes les variables sont alignes sur 16 octets pour une question de rapidit
.CODE
ALIGN 16
;
; placer un sprite centr  un emplacement X,Y de l'cran
;
; Rceptionne :
; eax = position X du sprite  afficher
; ebx = position Y du sprite  afficher
; esi = adresse (offset) de la structure _Informations_Sprite_
; edi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran de destination
;
; Retourne :
; rien
;
; Syntaxe : AfficherSprite_Centre
;
AfficherSprite_Centre PROC

		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; on va dterminer les limites du sprite
		mov ebp,edi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
		mov ecx,(_Informations_Sprite_ PTR [esi])._Largeur_Sprite_	;; ajouter la largeur du sprite  ecx
		mov edx,(_Informations_Sprite_ PTR [esi])._Hauteur_Sprite_	;; ajouter la hauteur du sprite  edx
		shr ecx,1									;; diviser la largeur par 2
		shr edx,1									;; diviser la hauteur par 2
		sub eax,ecx								;; enlever la moitie de la largeur  la position X
		sub ebx,edx								;; enlever la moitie de la hauteur  la position Y
		mov ecx,eax								;; copier la position X dans ecx
		mov edx,ebx								;; copier la position Y dans edx
		add ecx,(_Informations_Sprite_ PTR [esi])._Largeur_Sprite_	;; ajouter la largeur du sprite  ecx
		add edx,(_Informations_Sprite_ PTR [esi])._Hauteur_Sprite_	;; ajouter la hauteur du sprite  edx
; ici, on teste si les limites du sprite se situent bien dans l'cran, sinon on sort...
		test eax,eax								;; fixer les flags de eax
		js Label001								;; si c'est sign, aller Label001
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_	;; comparer eax  la largeur
		jge Label002								;; si c'est suprieur ou gal, aller Label002
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_	;; comparer X2  x._Largeur_Ecran_
		jae Label009								;; si la coordonne X2 est suprieure ou gale  LargeurEcranVirtuel, aller Label009
		test ebx,ebx								;; fixer les flags de ebx
		js Label003								;; si c'est sign, aller Label003
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_	;; comparer ebx  la hauteur
		jge Label004								;; si c'est suprieur ou gal, aller Label004
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_	;; comparer Y2  x._Hauteur_Ecran_
		jae Label009								;; si la coordonne Y2 est suprieure ou gale  HauteurEcranVirtuel, aller Label009
		jmp Label005								;; sinon, les 2 points sont  l'cran, alors aller Label005
; ici on s'assure que les limites ne sortent pas de l'cran du mme cot, sinon on sort
Label001:	test ecx,ecx								;; fixer les flags de ecx
		jns Label009								;; si ce n'est pas sign, aller Label009
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Label002:	cmp ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_	;; comparer ecx  la largeur
		jl Label009								;; si c'est infrieur sign, aller Label009
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Label003:	test edx,edx								;; fixer les flags de edx
		jns Label009								;; si ce n'est pas sign, aller Label009
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Label004:	cmp edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_	;; comparer edx  la hauteur
		jl Label009								;; si c'est infrieur sign, aller Label009
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)


;ALIGN 16
;
; ici, le sprite est entirement dans l'cran
;

; on initialise les variables que l'on va utiliser
Label005:	shl eax,2									;; multiplier la position X par 4
		mov (_Informations_Sprite_ PTR [esi])._Position_X_,eax	;; sauvegarder la position dans la variable x._Position_X_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; placer l'adresse de dpart de l'cran dans edx
; on dfini la position Y dans l'cran
		mov eax,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne cran x4 dans ecx
		imul ebx									;; multiplier eax (largeur *4) par la hauteur
		mov (_Informations_Sprite_ PTR [esi])._Position_Y_,eax	;; sauvegarder la position dans la variable x._Position_Y_
		add edi,eax								;; ajouter la position Y  l'adresse de dpart
; on traite le sprite
		mov ecx,esi								;; sauvegarder l'adresse de la structure du sprite  afficher dans ecx
		mov esi,(_Informations_Sprite_ PTR [ecx])._Pointeur_Sprite_	;; placer l'adresse du sprite dans esi
		add edi,(_Informations_Sprite_ PTR [ecx])._Position_X_	;; l on dfini clairement edi
		mov eax,(_Informations_Sprite_ PTR [ecx])._Hauteur_Sprite_	;; ) dfinir le ompteur de boucle pour la hauteur
		mov _Sprite_Boucle_Hauteur_,eax				;; )
		mov eax,(_Informations_Sprite_ PTR [ecx])._Couleur_Transparente_	;; placer la couleur de la transparence dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;;	) l on calcule le complment d'une ligne (largeur cran - largeur sprite)
		sub ebx,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;;	)
		mov _Sprite_Complement_Largeur_X4_,ebx			;;	)
;ALIGN 16
; boucle pour la hauteur, on dfini la boucle pour la largeur
Label006:	mov ebx,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;; placer la largeur du sprite *4 dans edx
		add esi,ebx								;; ajouter la largeur (*4) du sprite  esi
		add edi,ebx								;; ajouter la largeur (*4) du sprite  edi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour la largeur)
;ALIGN 16
; boucle pour la largeur, placer le pixel en fonction de la couleur
Label007:	mov edx,DWORD PTR [esi+ebx]					;; placer la couleur (le pixel)  l'adresse en esi+eax dans edx
		cmp edx,eax								;; comparer la couleur  celle de la transparence
		je Label008								;; si c'est gal, aller Label008
		mov DWORD PTR [edi+ebx],edx					;; sinon, placer la couleur (le pixel)  l'adresse en edi+ebx
; fin boucle largeur
Label008:	add ebx,4									;; enlever 1 pixel  notre compteur de boucle
		jnz Label007								;; tant que c'est diffrent de 0, aller Label007
; sinon, on passe  la ligne suivante
		add edi,_Sprite_Complement_Largeur_X4_			;; ajouter le complement d'une largeur de ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		dec _Sprite_Boucle_Hauteur_					;; fixer les flags du compteur en hauteur (le compteur de boucle pour la hauteur)
		jnz Label006								;; tant que eax n'est pas gal  zro, aller Label006
; sinon, on sort puisque le sprite est entirement dessin
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)


;ALIGN 16
;
; ici, le sprite n'est pas entirement dans l'cran
;

; on initialise les variables que l'on va utiliser
Label009:	shl eax,2									;; multiplier la position X par 4
		mov (_Informations_Sprite_ PTR [esi])._Position_X_,eax	;; sauvegarder la position dans la variable x._Position_X_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; placer l'adresse de dpart de l'cran dans edx
; on dfini la position Y dans l'cran
		mov eax,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne cran x4 dans eax
		imul ebx									;; multiplier eax (largeur *4) par la hauteur
		mov (_Informations_Sprite_ PTR [esi])._Position_Y_,eax	;; sauvegarder la position dans la variable x._Position_Y_
		add edi,eax								;; ajouter la position Y  l'adresse de dpart
; on traite le sprite
		mov ecx,esi								;; sauvegarder l'adresse de la structure du sprite  afficher dans ecx
		mov esi,(_Informations_Sprite_ PTR [ecx])._Pointeur_Sprite_	;; placer l'adresse du sprite dans esi
		mov eax,(_Informations_Sprite_ PTR [ecx])._Taille_Sprite_X4_	;; lire la taille *4 du sprite
		add esi,eax								;; ajouter eax  esi
		neg eax									;; inverser eax (qui devient notre compteur de boucle pour la hauteur)
		mov ebx,(_Informations_Sprite_ PTR [ecx])._Position_X_	;; placer la position cran X dans ebx
;ALIGN 16
; boucle pour la hauteur
Label010:	mov edx,edi								;; ) test de prsence cran Y
		sub edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; )
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;; )
		jae Label013								;; )
; sinon, on dfini la boucle pour la largeur
		mov edx,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;; placer la largeur du sprite *4 dans edx
		mov _Sprite_Boucle_Largeur_,edx				;; et la recopier dans _Sprite_Boucle_Largeur_ (qui sera notre compteur de boucle)
;ALIGN 16
; boucle pour la largeur, placer la couleur approprie en fonction du bit positionn
Label011:	cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de presence cran X
		jae Label012								;; )
		mov edx,DWORD PTR [esi+eax]					;; placer la couleur (le pixel)  l'adresse en esi+eax dans edx
		cmp edx,(_Informations_Sprite_ PTR [ecx])._Couleur_Transparente_	;; comparer la couleur  celle de la transparence
		je Label012								;; si c'est gal, aller Label012
		mov DWORD PTR [edi+ebx],edx					;; sinon, placer la couleur (le pixel)  l'adresse en edi+ebx
Label012:	add eax,4									;; pour lire le pixel suivant du sprite
		add ebx,4									;; pour aller traiter le pixel suivant de la ligne cran
; fin boucle largeur
		sub _Sprite_Boucle_Largeur_,4					;; enlever 1 pixel  notre compteur de boucle
		jnz Label011								;; tant que c'est diffrent de 0, aller Label011
; sinon, on passe  la ligne suivante
		sub ebx,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;; soustraire la largeur traite, pour paser  la ligne suivante
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		test eax,eax								;; fixer les flags de eax (le compteur de boucle pour la hauteur)
		jnz Label010								;; tant que eax n'est pas gal  zro, aller Label010
; sinon, on sort puisque le sprite est entirement dessin
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)

;ALIGN 16
; ici, la ligne du sprite n'a pas  tre traite
Label013:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		add eax,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;; fixer les flags de eax (le compteur de boucle pour la hauteur)
		jnz Label010								;; tant que eax n'est pas gal  zro, aller Label010
; sinon, on sort puisque le sprite est entirement dessin
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
AfficherSprite_Centre ENDP


ALIGN 16
;
; dcrmenter les alphas d'un sprite (pour rendre un sprite plus transparent) de 8 pas (pour avoir 32 possibilits)
;
; Rceptionne :
; esi = adresse (offset) de la structure _Informations_Sprite_
;
; Retourne :
; eax = niveau de transparence actuel (format 0,A,A,A)
;
; Syntaxe : DecrementerSpriteAlphas
;
DecrementerSpriteAlphas PROC

		mov eax,(_Informations_Sprite_ PTR [esi])._Niveau_Transparence_
		cmp eax,000000000h							;; comparer le niveau  0,0,0,0
		je Label001								;; si c'est gal, aller Label001
		cmp eax,000070707h							;; comparer le niveau  0,7,7,7
		jle Label002								;; si c'est infrieur ou gal sign, aller Label002
		sub eax,000080808h							;; sinon enlever 0,8,8,8  eax
		mov DWORD PTR [(_Informations_Sprite_ PTR [esi])._Niveau_Transparence_],eax	;; placer le nouvel alpha dans la structure
		call ModifierSpriteAlphas					;; et modifier l'alpha des pixels non-transparent en consquence
Label001:
	ret											;; retourner
Label002:
		mov eax,000000000h							;; placer 0 (l'alpha minimal) dans eax
		mov DWORD PTR [(_Informations_Sprite_ PTR [esi])._Niveau_Transparence_],eax	;; placer le nouvel alpha dans la structure
		call ModifierSpriteAlphas					;; et modifier l'alpha des pixels non-transparent en consquence
	ret											;; retourner
DecrementerSpriteAlphas ENDP


ALIGN 16
;
; incrmenter les alphas d'un sprite (pour rendre un sprite moins transparent) de 8 pas (pour avoir 32 possibilits)
;
; Rceptionne :
; esi = adresse (offset) de la structure _Informations_Sprite_
;
; Retourne :
; eax = niveau de transparence actuel (format 0,A,A,A)
;
; Syntaxe : IncrementerSpriteAlphas
;
IncrementerSpriteAlphas PROC

		mov eax,(_Informations_Sprite_ PTR [esi])._Niveau_Transparence_
		cmp eax,000FFFFFFh							;; comparer le niveau  0,255,255,255
		je Label001								;; si c'est gal, aller Label001
		cmp eax,000F8F8F8h							;; comparer le niveau  0,248,248,248
		jge Label002								;; si c'est suprieur ou gal sign, aller Label002
		add eax,000080808h							;; sinon ajouter 0,8,8,8  eax
		mov DWORD PTR [(_Informations_Sprite_ PTR [esi])._Niveau_Transparence_],eax	;; placer le nouvel alpha dans la structure
		call ModifierSpriteAlphas					;; et modifier l'alpha des pixels non-transparent en consquence
Label001:
	ret											;; retourner
Label002:
		mov eax,000FFFFFFh							;; placer 0,255,255,255 (l'alpha maximal) dans eax
		mov DWORD PTR [(_Informations_Sprite_ PTR [esi])._Niveau_Transparence_],eax	;; placer le nouvel alpha dans la structure
		call ModifierSpriteAlphas					;; et modifier l'alpha des pixels non-transparent en consquence
	ret											;; retourner
IncrementerSpriteAlphas ENDP


ALIGN 16
;
; initialiser un sprite (on va remplir une structure _Informations_Sprite_ relatif au sprite)
;
; Rceptionne :
; edx = adresse (offset) des donnes du sprite
; esi = adresse (offset) de la structure _Informations_Sprite_
; edi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran de destination
;
; Retourne :
; rien
;
; Syntaxe : InitialiserSprite
;
InitialiserSprite PROc
		push eax									;; empiler eax
		push edx									;; empiler edx

		mov eax,[edx+8]							;; placer l'adresse des donnes dans eax
		mov (_Informations_Sprite_ PTR [esi])._Pointeur_Sprite_,eax	;; sauvegarder l'adresse des donnes
		mov eax,[edx+12]							;; placer la couleur de transparence dans eax
		mov (_Informations_Sprite_ PTR [esi])._Couleur_Transparente_,eax	;; sauvegarder la couleur de transparence
		mov eax,[edx]								;; placer la largeur du sprite dans eax
		mov (_Informations_Sprite_ PTR [esi])._Largeur_Sprite_,eax	;; sauvegarder la largeur
		mov edx,[edx+4]							;; placer la hauteur du sprite dans edx
		mov (_Informations_Sprite_ PTR [esi])._Hauteur_Sprite_,edx	;; sauvegarder la hauteur
		mul edx									;; multiplier eax (la largeur) par la hauteur
		mov (_Informations_Sprite_ PTR [esi])._Taille_Sprite_,eax	;; sauvegarder la taille
		shl eax,2									;; multiplier la taille par 4 (pour avoir le nombre de dwords)
		mov (_Informations_Sprite_ PTR [esi])._Taille_Sprite_X4_,eax	;; sauvegarder la taille *4
		mov eax,(_Informations_Sprite_ PTR [esi])._Largeur_Sprite_	;; lire la largeur
		shl eax,2									;; multiplier la largeur par 4 (pour avoir le nombre de dwords)
		mov (_Informations_Sprite_ PTR [esi])._Largeur_Sprite_X4_,eax	;; sauvegarder la largeur *4
; calcul de la hauteur virtuelle
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer une ligne cran dans eax
		mul (_Informations_Sprite_ PTR [esi])._Hauteur_Sprite_		;; la multiplier par la hauteur du sprite
		mov (_Informations_Sprite_ PTR [esi])._Hauteur_Virtuelle_,eax	;; sauvegarder la hauteur virtuelle en ligne cran
; definir le niveau de transparence du sprite
		mov (_Informations_Sprite_ PTR [esi])._Niveau_Transparence_,000FFFFFFh	;; placer le niveau de transparence par dfaut dans la structure

		pop edx									;; dsempiler edx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
InitialiserSprite ENDP


ALIGN 16
;
; modifier l'alpha des couleurs d'un sprite (sauf celles concernant la transparence du sprite, videment...)
;
; Rceptionne :
; eax = l'alpha  appliquer au sprite dans (format 0,A,A,A)
; esi = adresse (offset) de la structure _Informations_Sprite_
;
; Retourne :
; rien
;
; syntaxe : ModifierSpriteAlphas
;
ModifierSpriteAlphas PROC

		mov (_Informations_Sprite_ PTR [esi])._Niveau_Transparence_,eax	;; placer la taille x4 dans ecx

	ret											;; retourner (sortir de la procdure)
ModifierSpriteAlphas ENDP


.DATA
ALIGN 16
_Sprite_Mmx_Masques_RVB_unpck_	DWORD 000FF00FFh,000FF00FFh,000FF00FFh,000FF00FFh

.CODE
ALIGN 16
;
; placer un sprite centr  un emplacement X,Y de l'cran (cette version turbo, qui est beaucoup plus rapide,
; considre que tous les alphas du sprite ont la mme valeur, ce qui est gnralement le cas...)
;
; Rceptionne :
; eax = position X du sprite  afficher
; ebx = position Y du sprite  afficher
; edx = alphas du sprite (format 0,A,A,A)
; esi = adresse (offset) de la structure _Informations_Sprite_
; edi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran de destination
;
; Retourne :
; rien
;
; Syntaxe : Mmx_AfficherSprite_Centre_Alpha_Turbo
;
Mmx_AfficherSprite_Centre_Alpha_Turbo PROC

		movd MM2,edx								;; MM2 = 0,A,A,A
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; on va dterminer les limites du sprite
		mov ebp,edi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
		mov ecx,(_Informations_Sprite_ PTR [esi])._Largeur_Sprite_	;; ajouter la largeur du sprite  ecx
		mov edx,(_Informations_Sprite_ PTR [esi])._Hauteur_Sprite_	;; ajouter la hauteur du sprite  edx
		shr ecx,1									;; diviser la largeur par 2
		shr edx,1									;; diviser la hauteur par 2
		sub eax,ecx								;; enlever la moitie de la largeur  la position X
		sub ebx,edx								;; enlever la moitie de la hauteur  la position Y
		mov ecx,eax								;; copier la position X dans ecx
		mov edx,ebx								;; copier la position Y dans edx
		add ecx,(_Informations_Sprite_ PTR [esi])._Largeur_Sprite_	;; ajouter la largeur du sprite  ecx
		add edx,(_Informations_Sprite_ PTR [esi])._Hauteur_Sprite_	;; ajouter la hauteur du sprite  edx
; ici, on teste si les limites du sprite se situent bien dans l'cran, sinon on sort...
		test eax,eax								;; fixer les flags de eax
		js Label001								;; si c'est sign, aller Label001
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_	;; comparer eax  la largeur
		jge Label002								;; si c'est suprieur ou gal, aller Label002
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_	;; comparer X2  x._Largeur_Ecran_
		jae Label009								;; si la coordonne X2 est suprieure ou gale  LargeurEcranVirtuel, aller Label009
		test ebx,ebx								;; fixer les flags de ebx
		js Label003								;; si c'est sign, aller Label003
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_	;; comparer ebx  la hauteur
		jge Label004								;; si c'est suprieur ou gal, aller Label004
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_	;; comparer Y2  x._Hauteur_Ecran_
		jae Label009								;; si la coordonne Y2 est suprieure ou gale  HauteurEcranVirtuel, aller Label009
		jmp Label005								;; sinon, les 2 points sont  l'cran, alors aller Label005
; ici on s'assure que les limites ne sortent pas de l'cran du mme cot, sinon on sort
Label001:	test ecx,ecx								;; fixer les flags de ecx
		jns Label009								;; si ce n'est pas sign, aller Label009
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Label002:	cmp ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_	;; comparer ecx  la largeur
		jl Label009								;; si c'est infrieur sign, aller Label009
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Label003:	test edx,edx								;; fixer les flags de edx
		jns Label009								;; si ce n'est pas sign, aller Label009
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Label004:	cmp edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_	;; comparer edx  la hauteur
		jl Label009								;; si c'est infrieur sign, aller Label009
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)


;ALIGN 16
;
; ici, le sprite est entirement dans l'cran
;

; on initialise les variables que l'on va utiliser
Label005:	shl eax,2									;; multiplier la position X par 4
		mov (_Informations_Sprite_ PTR [esi])._Position_X_,eax	;; sauvegarder la position dans la variable x._Position_X_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; placer l'adresse de dpart de l'cran dans edx
; on dfini la position Y dans l'cran
		mov eax,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne cran x4 dans ecx
		imul ebx									;; multiplier eax (largeur *4) par la hauteur
		mov (_Informations_Sprite_ PTR [esi])._Position_Y_,eax	;; sauvegarder la position dans la variable x._Position_Y_
		add edi,eax								;; ajouter la position Y  l'adresse de dpart
; on traite le sprite
		mov ecx,esi								;; sauvegarder l'adresse de la structure du sprite  afficher dans ecx
		mov esi,(_Informations_Sprite_ PTR [ecx])._Pointeur_Sprite_	;; placer l'adresse du sprite dans esi
		add edi,(_Informations_Sprite_ PTR [ecx])._Position_X_	;; l on dfini clairement edi
		mov eax,(_Informations_Sprite_ PTR [ecx])._Hauteur_Sprite_	;; ) dfinir le ompteur de boucle pour la hauteur
		mov _Sprite_Boucle_Hauteur_,eax				;; )
		mov eax,(_Informations_Sprite_ PTR [ecx])._Couleur_Transparente_	;; placer la couleur de la transparence dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;;	) l on calcule le complment d'une ligne (largeur cran - largeur sprite)
		sub ebx,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;;	)
		mov _Sprite_Complement_Largeur_X4_,ebx			;;	)
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
		punpcklbw MM2,MM7							;; MM2 = 0,0,0,A , 0,A,0,A (masque alpha 1)
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Sprite_Mmx_Masques_RVB_unpck_	;; MM3 = 0,0,0,A , 0,A,0,A (masque alpha 2)
;ALIGN 16
; boucle pour la hauteur, on dfini la boucle pour la largeur
Label006:	mov ebx,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;; placer la largeur du sprite *4 dans edx
		add esi,ebx								;; ajouter la largeur (*4) du sprite  esi
		add edi,ebx								;; ajouter la largeur (*4) du sprite  edi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour la largeur)
;ALIGN 16
; boucle pour la largeur, placer le pixel en fonction de la couleur
Label007:	mov edx,DWORD PTR [esi+ebx]					;; placer la couleur (le pixel)  l'adresse en esi+eax dans edx
		cmp edx,eax								;; comparer la couleur  celle de la transparence
		je Label008								;; si c'est gal, aller Label008
; sinon, application de la transparence alpha sur le pixel
		movd MM0,DWORD PTR [edi+ebx]					;; MM0 = _,R,V,B (lire la couleur de fond)
		movd MM1,edx								;; MM1 = _,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,_,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,_,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = 0*_,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = 0*_,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = 0*_+0*_,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,_,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = _,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+ebx],MM0					;; placer la couleur (le pixel)  l'adresse en edi+ebx
; fin boucle largeur
Label008:	add ebx,4									;; enlever 1 pixel  notre compteur de boucle
		jnz Label007								;; tant que c'est diffrent de 0, aller Label007
; sinon, on passe  la ligne suivante
		add edi,_Sprite_Complement_Largeur_X4_			;; ajouter le complement d'une largeur de ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		dec _Sprite_Boucle_Hauteur_					;; fixer les flags du compteur en hauteur (le compteur de boucle pour la hauteur)
		jnz Label006								;; tant que eax n'est pas gal  zro, aller Label006
; sinon, on sort puisque le sprite est entirement dessin
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)


;ALIGN 16
;
; ici, le sprite n'est pas entirement dans l'cran
;

; on initialise les variables que l'on va utiliser
Label009:	shl eax,2									;; multiplier la position X par 4
		mov (_Informations_Sprite_ PTR [esi])._Position_X_,eax	;; sauvegarder la position dans la variable x._Position_X_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; placer l'adresse de dpart de l'cran dans edx
; on dfini la position Y dans l'cran
		mov eax,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne cran x4 dans eax
		imul ebx									;; multiplier eax (largeur *4) par la hauteur
		mov (_Informations_Sprite_ PTR [esi])._Position_Y_,eax	;; sauvegarder la position dans la variable x._Position_Y_
		add edi,eax								;; ajouter la position Y  l'adresse de dpart
; on traite le sprite
		mov ecx,esi								;; sauvegarder l'adresse de la structure du sprite  afficher dans ecx
		mov esi,(_Informations_Sprite_ PTR [ecx])._Pointeur_Sprite_	;; placer l'adresse du sprite dans esi
		mov eax,(_Informations_Sprite_ PTR [ecx])._Taille_Sprite_X4_	;; lire la taille *4 du sprite
		add esi,eax								;; ajouter eax  esi
		neg eax									;; inverser eax (qui devient notre compteur de boucle pour la hauteur)
		mov ebx,(_Informations_Sprite_ PTR [ecx])._Position_X_	;; placer la position cran X dans ebx
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
		punpcklbw MM2,MM7							;; MM2 = 0,0,0,A , 0,A,0,A (masque alpha 1)
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Sprite_Mmx_Masques_RVB_unpck_	;; MM3 = 0,0,0,A , 0,A,0,A (masque alpha 2)
;ALIGN 16
; boucle pour la hauteur
Label010:	mov edx,edi								;; ) test de prsence cran Y
		sub edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; )
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;; )
		jae Label013								;; )
; sinon, on dfini la boucle pour la largeur
		mov edx,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;; placer la largeur du sprite *4 dans edx
		mov _Sprite_Boucle_Largeur_,edx				;; et la recopier dans _Sprite_Boucle_Largeur_ (qui sera notre compteur de boucle)
;ALIGN 16
; boucle pour la largeur, placer la couleur approprie en fonction du bit positionn
Label011:	cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de presence cran X
		jae Label012								;; )
		mov edx,DWORD PTR [esi+eax]					;; placer la couleur (le pixel)  l'adresse en esi+eax dans edx
		cmp edx,(_Informations_Sprite_ PTR [ecx])._Couleur_Transparente_	;; comparer la couleur  celle de la transparence
		je Label012								;; si c'est gal, aller Label012
; sinon, application de la transparence alpha sur le pixel
		movd MM0,DWORD PTR [edi+ebx]					;; MM0 = _,R,V,B (lire la couleur de fond)
		movd MM1,edx								;; MM1 = _,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,_,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,_,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = 0*_,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = 0*_,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = 0*_+0*_,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,_,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = _,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+ebx],MM0					;; placer la couleur (le pixel)  l'adresse en edi+ebx
Label012:	add eax,4									;; pour lire le pixel suivant du sprite
		add ebx,4									;; pour aller traiter le pixel suivant de la ligne cran
; fin boucle largeur
		sub _Sprite_Boucle_Largeur_,4					;; enlever 1 pixel  notre compteur de boucle
		jnz Label011								;; tant que c'est diffrent de 0, aller Label011
; sinon, on passe  la ligne suivante
		sub ebx,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;; soustraire la largeur traite, pour paser  la ligne suivante
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		test eax,eax								;; fixer les flags de eax (le compteur de boucle pour la hauteur)
		jnz Label010								;; tant que eax n'est pas gal  zro, aller Label010
; sinon, on sort puisque le sprite est entirement dessin
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)

;ALIGN 16
; ici, la ligne du sprite n'a pas  tre traite
Label013:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		add eax,(_Informations_Sprite_ PTR [ecx])._Largeur_Sprite_X4_	;; fixer les flags de eax (le compteur de boucle pour la hauteur)
		jnz Label010								;; tant que eax n'est pas gal  zro, aller Label010
; sinon, on sort puisque le sprite est entirement dessin
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AfficherSprite_Centre_Alpha_Turbo ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine de conversion valeur -> chaine de caractre dcimale
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; convertir un dword en texte au format dcimale (routine la plus stable pour le job)
; note : cette routine n'est pas de moi, je sais plus o je l'ai rcupre, mais si je me souviens bien,
; c'est une adaption d'un algo cr par pdixon/michealw (ou quelque chose comme c... au dbut, j'aimait pas
; trop le bidouillage qui faisait passer le +1 en eax dans le multiplicateur, mais aprs tout, si ca fait le job,
; pourquoi pas...)
;
; Rceptionne :
; eax = la valeur
; esi = adresse de la chaine de caractres  crer
;


; Retourne :
; rien
;
; syntaxe : ConvertirValeurEnChaineDecimale
;
ConvertirValeurEnChaineDecimale PROC
		push eax									;; empiler eax
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push esi									;; empiler esi

		mov ecx,eax								;; copier eax dans ecx
; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768							;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx									;; multiplier eax par 2814749768
		shr edx,16								;; dcaler edx de 16 bits  droite
		mov eax,100000								;; placer 100000 dans eax
		mov ebx,edx								;; copier edx dans ebx

		mul edx									;; multiplier edx par 100000
		sub ecx,eax								;; soustraire le rsultat en eax  ecx
		test ebx,ebx								;; fixer les flags de ebx
		mov edx,ebx								;; replacer ebx dans edx
		mov ebx,10								;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01								;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497								;; on remplace eax par 429497
		mul edx									;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label02								;; s'il existe un dpassement, aller Label02
		mul ebx									;; multiplier eax par 10
		jc Label03								;; s'il existe un dpassement, aller Label03
		mul ebx									;; multiplier eax par 10
		jc Label04								;; s'il existe un dpassement, aller Label04
		mul ebx									;; multiplier eax par 10
		jc Label05								;; s'il existe un dpassement, aller Label05
		mul ebx									;; multiplier eax par 10
		jc Label06								;; s'il existe un dpassement, aller Label06
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07								;; s'il existe un dpassement, aller Label07
		mul ebx									;; multiplier eax par 10
		jc Label08								;; s'il existe un dpassement, aller Label08
		mul ebx									;; multiplier eax par 10
		jc Label09								;; s'il existe un dpassement, aller Label09
		mul ebx									;; multiplier eax par 10
		jc Label10								;; s'il existe un dpassement, aller Label10
		mul ebx									;; multiplier eax par 10
		jmp Label11								;; aller Label11
; maintenant on va calculer et copier chaque octets/caractres
Label02:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label03:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label04:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label05:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label06:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi

		mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)

		inc esi									;; ajouter 1 octet  l'adresse en esi
Label07:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label08:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label09:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label10:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label11:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mov BYTE PTR [esi+1],0						;; placer le 0 final  l'adresse en esi+1
		xor eax,eax								;; effacer eax

		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
ConvertirValeurEnChaineDecimale ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement de chaines de caractres graphiques
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Chaine_Position_Ecran_X_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Position_Ecran_Y_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Boucle_Largeur_			DWORD ?,?,?,?			;; (align 16)
_Chaine_Adresse_Police_			DWORD ?,?,?,?			;; (align 16)
_Chaine_Couleur_Police_			DWORD 000FFFFFFh,?,?,?	;; (align 16) blanc par dfaut
_Chaine_Couleur_Fond_			DWORD 000000000h,?,?,?	;; (align 16) noir par dfaut
_Chaine_Adresse_Caractere_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Largeur_Caractere_X4_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Passage_Caractere_Suivant_	DWORD ?,?,?,?			;; (align 16)
_Chaine_Hauteur_Police_			DWORD ?,?,?,?			;; (align 16)
; note : ici, toutes les variables sont alignes sur 16 octets pour une question de rapidit
.CODE
ALIGN 16
;
; dfinir les couleurs (caractres + fond) d'une chane de caractres
; note : ca peut paraitre stupide de crer une procdure avec seulement 2 instructions, mais ca permet d'eviter
; de rpeter cette opration systmatiquement dans AfficherChaine (gain de vitesse), et c'est aussi quelque chose
; qui peut tre appel un nombre de fois considrable (donc, une macro prendrai beucoup plus d'espace mmoire)
;
; Rceptionne :
; eax = couleur de la police de caractres
; ebx = couleur de fond de la police de caractres
;
; Retourne :
; rien, mais les variables _Chaine_Couleur_Police_ et _Chaine_Couleur_Fond_ qui servent pour AfficherChaine est dfinie
;
; Syntaxe : DefinirCouleursChaine
;
DefinirCouleursChaine PROC
		mov _Chaine_Couleur_Police_,eax				;; sauvegarder la couleur de la police
		mov _Chaine_Couleur_Fond_,ebx					;; sauvegarder la couleur de fond de la police
	ret											;; retourner (sortir de la procdure)
DefinirCouleursChaine ENDP


ALIGN 16
;
; obtenir la largeur (en pixels) d'une chane de caractres a afficher en fonction de la police utilise
;
; Rceptionne :
; edx = adresse de la police de caratres  utiliser
; esi = adresse de la chaine  afficher
;
; Retourne :
; eax = la largeur de la chane  afficher en pixels
;
; Syntaxe : ObtenirLargeurChaine
;
ObtenirLargeurChaine PROC
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push esi									;; empiler esi
		push edi									;; empiler edi

		xor ebx,ebx								;; effacer ebx, qui sera le registre "compteur"
		mov ecx,edx								;; copier edx dans ecx
		mov edi,DWORD PTR [edx]						;; placer la hauteur des caractres de la police dans edi
		shl edi,2									;; multiplier edi par 4 (puisque, ici, on lit des dwords)
		add edi,DWORD								;; ajouter le dword correspondant  la largeur du caractres
; on teste si c'est la fin de chane
Label01:	movzx eax,BYTE PTR [esi]						;; placer le caractre  afficher dans eax
		test eax,eax								;; fixer les flags de eax
		jz Label04								;; si eax est gal  zro (fin de chane), aller Label04 (la sortie)
; sinon, on simule la lecture du caractre
		cmp eax,32								;; comparer le caractre  32 (caractre minimal  afficher)
		jb Label03								;; si c'est infrieur  32, aller Label03
		cmp eax,DWORD PTR [ecx+4]					;; comparer notre caractre au caractre maximal trait par la police
		jbe Label02								;; si c'est infrieur ou gal au caractre maximal, aller Label02
		mov eax,127								;; sinon, placer 127 (le caractre maxi d'une police restreinte) dans eax
Label02:	sub eax,32								;; enlever les 32 caractres "non affichables"  eax
; on calcule l'emplacement des donnes du caractre  afficher
		mul edi									;; multiplier le caractre par la "hauteur" des caractres
		add eax,ecx								;; ajouter l'adresse de dpart de la police au rsultat obtenu en eax
; on ajoute la largeur du caractre en cours
		add ebx,DWORD PTR [eax+8]					;; ajouter la largeur du caractre  ebx (+8,  pour le dword de la hauteur, et le dword du caractre maxi)
Label03:	inc esi									;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01								;; aller Label01
Label04:	mov eax,ebx								;; placer la largeur obtenue dans eax

		pop edi									;; dsempiler edi
		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)
ObtenirLargeurChaine ENDP


.DATA
ALIGN 16
_Chaine_Mmx_Masque_Alpha_movd_	DWORD 0FF000000h,0FF000000h,0FF000000h,0FF000000h
_Chaine_Mmx_Masque_ARVB_unpck_	DWORD 000FF00FFh,000FF00FFh,000FF00FFh,000FF00FFh


.CODE
ALIGN 16
;
; Afficher une chane de caractres (largeur maximale des caractres de la police = 32 pixels, (ce qui est suffisant
; dans la plupart des cas...))
;
; Rceptionne :
; eax = position X (largeur en pixels) de dpart
; ebx = position Y (hauteur en pixels) de dpart
; edx = adresse de la police de caratres  utiliser
; esi = adresse de la chaine  afficher
; edi = adresse (offset) de la structure cran
;
; Retourne :
; rien, mais la chaine est affiche  l'cran (attention, tous les registre MMx sont modifis)
;
; Syntaxe : Mmx_AfficherChaine_Alpha
;
Mmx_AfficherChaine_Alpha PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

; on initialise les variables que l'on va utiliser
		mov ebp,edi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
		mov _Chaine_Adresse_Police_,edx				;; sauvegarder l'adresse de la police utilise
		mov _Chaine_Adresse_Caractere_,esi				;; sauvegarder l'adresse du caractre  afficher
		mov esi,DWORD PTR [edx]						;; placer la hauteur de la police dans esi
		mov _Chaine_Hauteur_Police_,esi				;; placer la hauteur de la police dans _Chaine_Hauteur_Police_
; calculer la position X
		shl eax,2									;; multiplier la position X par 4
		mov _Chaine_Position_Ecran_X_,eax				;; sauvegarder la position dans la variable _Chaine_Position_Ecran_X_
; calculer la zone cran
		mov ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne cran x4 dans ecx
		mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; placer l'adresse de dpart de l'cran dans edi
; calculer la position Y
		mov eax,ecx								;; placer la largeur d'une ligne cran x4 dans eax
		imul ebx									;; multiplier par la hauteur
; on dfini la position Y dans l'cran
		add edi,eax								;; ajouter la position Y  l'adresse de dpart
; calculer le dcalage cran pour passer au caractre suivant
		mov eax,ecx								;; placer la largeur d'une ligne cran x4 dans eax
		mul _Chaine_Hauteur_Police_					;; multiplier par la hauteur de la police
		mov _Chaine_Passage_Caractere_Suivant_,eax		;; sauvegarder le dcalage
		mov ebx,_Chaine_Position_Ecran_X_				;; placer la position  crire dans ebx
		movd MM5,DWORD PTR _Chaine_Mmx_Masque_Alpha_movd_	;; MM5 = M,0,0,0
		movq MM6,QWORD PTR _Chaine_Mmx_Masque_ARVB_unpck_	;; MM6 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0

;ALIGN 16
; on traite la chane de caractres, pour commencer on teste si c'est la fin de chane
Label01:	mov edx,_Chaine_Adresse_Caractere_				;; placer l'adresse du caractre  afficher dans edi
		movzx eax,BYTE PTR [edx]						;; placer le caractre  afficher dans eax
		test eax,eax								;; fixer les flags de eax
		jz Label14								;; si eax est gal  zro (fin de chane), aller Label14 (la sortie)
; sinon, on teste la validit du caractre
		cmp eax,32								;; comparer le caractre  32 (caractre minimal  afficher)
		jb Label07								;; si c'est infrieur  32, aller Label07
		mov esi,_Chaine_Adresse_Police_				;; placer l'adresse de la police dans esi
		mov ecx,DWORD PTR [esi]						;; et lire la hauteur des caractres
		shl ecx,2									;; multiplier ecx par 4 (puisque, ici, on lit des dwords)
		cmp eax,DWORD PTR [esi+4]					;; comparer notre caractre au caractre maximal trait par la police
		jbe Label02								;; si c'est infrieur ou gal au caractre maximal, aller Label02
		mov eax,127								;; sinon, placer 127 (le caractre maxi d'une police restreinte) dans eax
Label02:	sub eax,32								;; enlever les 32 caractres "non affichables"  eax
; on cherche l'emplacement des donnes du caractre  afficher
		add ecx,4									;; ajouter le dword correspondant  la largeur du caractre
		mul ecx									;; multiplier le caractre en eax par la "hauteur" des caractres
		add esi,eax								;; ajouter le rsultat obtenu  l'adresse de dpart de la police
; ici, esi+8 = largeur du caractre, et esi+12 = adresse des donnes du caractre
		mov eax,DWORD PTR [esi+8]					;; placer la largeur du caractre dans eax
		shl eax,2									;; multiplier cette largeur par 4 (puisqu'on lit des dwords)
		mov _Chaine_Largeur_Caractere_X4_,eax			;; sauvegarder la largeur du caractre *4 en cours de traitement
; on dfini la boucle pour la hauteur
		mov eax,_Chaine_Hauteur_Police_				;; lire la hauteur des caractres
		shl eax,2									;; multiplier cette hauteur par 4, (puisqu'on lit des dwords)
		add esi,eax								;; ajouter eax  esi
		neg eax									;; inverser eax (qui devient notre compteur de boucle pour la hauteur)

; on teste si le caractre est pleinement dans l'cran
		mov edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;; ) test de prsence cran Y
		mov ecx,edi								;; )
		sub ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; )
		cmp ecx,edx								;; )
		jae Label08								;; )
		add ecx,_Chaine_Passage_Caractere_Suivant_		;; )
		cmp ecx,edx								;; )
		jae Label08								;; )
		mov edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;;	) test de presence cran X
		mov ecx,ebx								;;	)
		cmp ecx,edx								;;	)
		jae Label08								;;	)
		add ecx,_Chaine_Largeur_Caractere_X4_			;;	)
		cmp ecx,edx								;;	)
		jae Label08								;;	)

;ALIGN 16
; ici, le caractre est entirement dans l'cran, boucle pour la hauteur, on dfini la boucle pour la largeur
Label03:	mov ecx,DWORD PTR [esi+eax+12]				;; placer le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la hauteur, le dword du caractre maxi et le dword de la largeur du caractre)
		mov edx,_Chaine_Largeur_Caractere_X4_			;; placer la largeur du caractre *4 dans edx
		mov _Chaine_Boucle_Largeur_,edx				;; et la recopier dans _Chaine_Boucle_Largeur_ (qui sera notre compteur de boucle)
;ALIGN 16
; boucle pour la largeur, placer la couleur approprie en fonction du bit positionn
Label04:	shl ecx,1									;; sinon, tester les bits "de 31  31-largeur"
		jnc Label05								;; si le flag carry n'est pas positionn, aller Label05
		mov edx,_Chaine_Couleur_Police_				;; placer la couleur de la police dans edx
		jmp Label06								;; aller Label06
Label05:	mov edx,_Chaine_Couleur_Fond_					;; placer la couleur du fond de la police dans edx
; ici, application de la transparence alpha sur le pixel
Label06:	movd MM0,DWORD PTR [edi+ebx]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movd MM1,edx								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		movd MM2,edx								;; MM2 = A,R,V,B
		pand MM2,MM5								;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,MM6								;; MM3 = 0,0,0,A , 0,A,0,A
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+ebx],MM0					;; placer la couleur (le pixel)  l'adresse en edi+ebx
		add ebx,4									;; pour aller traiter le pixel suivant de la ligne
; fin boucle largeur
		sub _Chaine_Boucle_Largeur_,4					;; enlever 1 pixel  notre compteur de boucle
		jnz Label04								;; tant que c'est diffrent de 0, aller Label04
; sinon, on passe  la ligne suivante
		sub ebx,_Chaine_Largeur_Caractere_X4_			;; soustraire la largeur traite, pour paser  la ligne suivante
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		add eax,4									;; incrmenter d'1 dword le compteur de boucle pour la hauteur
		jnz Label03								;; tant que eax n'est pas gal  zro, aller Label03
; sinon, on passe au caractre  afficher suivant
		sub edi,_Chaine_Passage_Caractere_Suivant_		;; soustraire le dcalage  edi
		add ebx,_Chaine_Largeur_Caractere_X4_			;; ajouter la largeur du caractre trait  ebx
; fin boucle caractres
Label07:	inc _Chaine_Adresse_Caractere_				;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01								;; aller Label01

;ALIGN 16
; ici, le caractre n'est pas entirement dans l'cran, boucle pour la hauteur
Label08:	mov ecx,edi								;; ) test de prsence cran Y
		sub ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; )
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;; )
		jae Label13								;; )
; sinon, on dfini la boucle pour la largeur
		mov ecx,DWORD PTR [esi+eax+12]				;; sinon, placer le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la hauteur, le dword du caractre maxi et le dword de la largeur du caractre)
		mov edx,_Chaine_Largeur_Caractere_X4_			;; placer la largeur du caractre *4 dans edx
		mov _Chaine_Boucle_Largeur_,edx				;; et la recopier dans _Chaine_Boucle_Largeur_ (qui sera notre compteur de boucle)
;ALIGN 16
; boucle pour la largeur, placer la couleur approprie en fonction du bit positionn
Label09:	shl ecx,1									;; sinon, tester les bits "de 31  31-largeur"
		jnc Label10								;; si le flag carry n'est pas positionn, aller Label10
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de presence cran X
		jae Label12								;; )
		mov edx,_Chaine_Couleur_Police_				;; placer la couleur de la police dans edx
		jmp Label11								;; aller Label11
Label10:	cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de presence cran X
		jae Label12								;; )
		mov edx,_Chaine_Couleur_Fond_					;; placer la couleur du fond de la police dans edx
; ici, application de la transparence alpha sur le pixel
Label11:	movd MM0,DWORD PTR [edi+ebx]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movd MM1,edx								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		movd MM2,edx								;; MM2 = A,R,V,B
		pand MM2,MM5								;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,MM6								;; MM3 = 0,0,0,A , 0,A,0,A
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+ebx],MM0					;; placer la couleur (le pixel)  l'adresse en edi+ebx
Label12:	add ebx,4									;; pour aller traiter le pixel suivant de la ligne
; fin boucle largeur
		sub _Chaine_Boucle_Largeur_,4					;; enlever 1 pixel  notre compteur de boucle
		jnz Label09								;; tant que c'est diffrent de 0, aller Label09
; sinon, on passe  la ligne suivante
		sub ebx,_Chaine_Largeur_Caractere_X4_			;; soustraire la largeur traite, pour paser  la ligne suivante
Label13:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		add eax,4									;; incrmenter d'1 dword le compteur de boucle pour la hauteur
		jnz Label08								;; tant que eax n'est pas gal  zro, aller Label08
; sinon, on passe au caractre  afficher suivant
		sub edi,_Chaine_Passage_Caractere_Suivant_		;; soustraire le dcalage  edi
		add ebx,_Chaine_Largeur_Caractere_X4_			;; ajouter la largeur du caractre trait  ebx
		inc _Chaine_Adresse_Caractere_				;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01								;; aller Label01
Label14:
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AfficherChaine_Alpha ENDP


ALIGN 16
;
; Afficher une chane de caractres centre (largeur maximale des caractres de la police = 32 pixels, (ce qui
; est suffisant dans la plupart des cas...))
;
; Rceptionne :
; eax = position X (largeur en pixels) de dpart
; ebx = position Y (hauteur en pixels) de dpart
; edx = adresse de la police de caratres  utiliser
; esi = adresse de la chaine  afficher
; edi = adresse (offset) de la structure cran
;
; Retourne :
; rien, mais la chaine est affiche  l'cran
;
; Syntaxe : Mmx_AfficherChaine_Centree_Alpha
;
Mmx_AfficherChaine_Centree_Alpha PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ecx,eax								;; copier eax dans ecx
		call ObtenirLargeurChaine					;; obtenir la largeur (en pixels) de la chaine qu'on vient d'afficher
		shr eax,1									;; diviser cette hauteur par 2
		sub ecx,eax								;; enlever la moitie de la largeur  ecx
		mov eax,ecx								;; placer ecx dans eax
		mov ecx,DWORD PTR [edx]						;; placer la hauteur de la police dans ecx
		shr ecx,1									;; diviser cette hauteur par 2
		sub ebx,ecx								;; enlever la moitie de la hauteur  ebx
		call Mmx_AfficherChaine_Alpha					;; afficher cette chane  la position spcifie

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AfficherChaine_Centree_Alpha ENDP

