;
; Test sprites/fondu
;

.686P											; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX												; pour activer les instructions mmx
.XMM												; pour activer les instructions sse,sse2
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED										; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP										; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE									; optionel: rends les identifiants sensibles  la casse de caractres


;
; fichiers INCLUDE
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \MAsm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
;INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \Masm32\INCLUDE\ .inc


;
; Fichiers LIBRAIRIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \MAsm32\LIB\masm32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
;INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \Masm32\LIB\ .lib


;
; les equivalences
;

Taille_Pile_Processus_Principal	EQU 16

Largeur_Ecran_Final				EQU 800
Hauteur_Ecran_Final				EQU 600
; note : ralentissement lorsque la taille de la fenetre diffre du bloc de travail, a cause du retaillage...
Largeur_Ecran_Travail			EQU 400	;800
Hauteur_Ecran_Travail			EQU 300	;600

Nombre_Sprites					EQU 128

Couleur_Rouge				EQU 000DF3F3Fh				;; 223,063,063 )
Couleur_Vert				EQU 0003FBF3Fh				;; 063,191,063 )
Couleur_Bleu				EQU 0003F3FDFh				;; 063,063,223 )
Couleur_Jaune				EQU 000DFDF3Fh				;; 223,223,063 )


;
; les prototypes
;

ProgrammePrincipal PROTO
GestionnaireMessages PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoiteDialogue PROTO :DWORD,:DWORD,:DWORD,:DWORD


.DATA
;
; Structures
;

; structure pour la cration/la suppression d'une l'instance mmoire
_Informations_Memoire_	STRUCT						;; pour un total de 16 octets
	_Instance_			DWORD ?					;; pointeur de l'instance
	_Taille_Initiale_		DWORD ?					;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?					;; taille maximale (dfinie par HeapCreate)
	_Inutilise_01_			DWORD ?					;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Informations_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_	STRUCT								;; pour un total de 16 octets
	_Taille_Du_Bloc_		DWORD ?					;; taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?					;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?					;; pointeur de la zone utilisable (align sur 16 octets)
	_Inutilise_01_			DWORD ?					;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Bloc_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire spcifique aux crans
_Bloc_Memoire_Ecran_	STRUCT						;; pour un total de 32 octets
	_Taille_Du_Bloc_		DWORD ?					;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?					;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?					;; pointeur de la zone utilisable (adresse aligne sur 16 octets)
	_Largeur_Ecran_		DWORD ?					;; largeur de l'cran (en pixels)
	_Largeur_Ecran_X4_		DWORD ?					;; (align 16) largeur de l'cran relle multiplie par 4 (*DWORD) (ajout, parceque souvent utilis, evite donc des shl,2)
	_Hauteur_Ecran_		DWORD ?					;; hauteur de l'cran (en pixels)
	_Pointeur_Zbuffer_		DWORD ?					;; pointeur de la zone Zbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	_Pointeur_LimitesFace_	DWORD ?					;; pointeur de la zone limites face (zro quand ce n'est pas un cran double)
_Bloc_Memoire_Ecran_	ENDS

; tampon contenant les infos spcifiques  un seul sprite
_Informations_Sprite_ STRUCT
	_Couleur_Transparente_	DWORD ?					;; (align 16) la couleur qui sert de transparence au sprite
	_Pointeur_Sprite_		DWORD ?					;; adresse du bloc mmoire qui contient le sprite
	_Position_X_			DWORD ?					;; )
	_Position_Y_			DWORD ?					;; ) positions relles dans l'cran
	_Largeur_Sprite_X4_		DWORD ?					;; (align 16) largeur de sprite * 4 (largeur en dwords) souvent utilis
	_Largeur_Sprite_		DWORD ?					;; largeur du sprite (en pixels)
	_Hauteur_Sprite_		DWORD ?					;; hauteur du sprite (en pixels)
	_Taille_Sprite_		DWORD ?					;; taille en pixels (taille thorique) du sprite
	_Taille_Sprite_X4_		DWORD ?					;; (align 16) largeur * hauteur * 4 (la taille relle du sprite)
	_inutilise_01_			DWORD ?					;; inutilis, pour le moment...
	_Niveau_Transparence_	DWORD ?					;; niveau de transparence du sprite (les alphas dfinis 0,A,A,A)
	_inutilise_02_			DWORD ?					;; inutilis, pour le moment...
	_Base_X_				DWORD ?					;; (align 16) base X du sprite (le x de rfrence)
	_Hauteur_Virtuelle_		DWORD ?					;; hauteur du sprite en lignes cran
	_Base_Y_				DWORD ?					;; base Y du sprite (le y de rfrence)
	_inutilise_03_			DWORD ?					;; inutilis, pour le moment...
_Informations_Sprite_ ENDS


;
; Variable dfinies
;
INCLUDE Police_Xx16.inc
INCLUDE Police_Xx20.inc
INCLUDE Sprite01.inc
INCLUDE Sprite02.inc


ALIGN 16
; les pointeurs
Pointeur_Ligne_Commandes			DWORD 0
Pointeur_Fenetre				DWORD 0
Pointeur_DC_Ecran				HDC ?
Pointeur_Processus_Principal		DWORD ?

Pointeur_DC_Bitmap				DWORD ?

; quelques compteurs
Compteur_Des_images				DWORD 0

; variables diverses
Instance_Application			DWORD 0
Instance_Boite_Dialogue			DWORD 0

; variables 2D
Position_Ecran_X				DWORD ?
Position_Ecran_Y				DWORD ?

Position_Souris_X	DWORD Largeur_Ecran_Travail/2
Position_Souris_Y	DWORD Hauteur_Ecran_Travail/2

Position_Chaine_X	DWORD 0
Position_Chaine_Y	DWORD 0


; les tmoins
Temoin_Poursuite_Processus		BYTE 1
Temoin_Redimensionnement			BYTE 0
Temoin_Statistiques				BYTE 1
Temoin_Chaine					BYTE 1
Temoin_Sprite					BYTE 1

Temoin_Effet_Fondu				BYTE 1
Temoin_Sens_Deplacement_Chaine_X	BYTE 0
Temoin_Sens_Deplacement_Chaine_Y	BYTE 0

; variables texte
Chaine_Type_Fenetre				BYTE "Application",0
Chaine_Titre_Fenetre			BYTE "Test sprites",0
Chaine_Boite_Dialogue_Insuffisant	BYTE "DialogueInsuffisant",0
Chaine_Boite_Dialogue_Quitter		BYTE "DialogueQuitter",0
Chaine_Images_Seconde			BYTE "Fps : "
Chaine_Nombre_Images_Seconde		BYTE 12 DUP(0h)
Chaine_Niveau_Transparence		BYTE "Niveau de l'alpha : "
Chaine_Nombre_Niveau_Transparence	BYTE 12 DUP(0h)


.DATA?
;
; Variables non dfinies
;
ALIGN 16


ALIGN 16
; definition des variables structures
Instance_Memoire				_Informations_Memoire_ <?>
Tampon_Ecran_Travail			_Bloc_Memoire_Ecran_ <?>
Tampon_Ecran_Final				_Bloc_Memoire_Ecran_ <?>
Tampon_Table_Redimensionnement	_Bloc_Memoire_ <?>
Tampon_Sprite_01				_Informations_Sprite_ <?>
Tampon_Sprite_02				_Informations_Sprite_ <?>
;_Bloc_Memoire_ <?>
Cadre_Ecran					RECT <?>				;; 4 Dwords
Informations_Fenetre			WNDCLASSEX <?>			;; 12 Dwords

; structure BITMAPINFO (elle est dcompose, parcequ'il semble qu'il y ai des difficults pour assembler du code
; lorsque la premire valeur d'une structure est une autre structure...
Informations_Bitmap				BITMAPINFOHEADER <?>	;; ) bmiHeader (BITMAPINFOHEADER) (3 Dwords + 2 Words + 6 Dwords) + bmiColors (RGBQUAD) (4 octets)
Informations_Bitmap_Suite_1		RGBQUAD <?>			;; )

Position_Pointeur_Ecran			POINT <?>				;; 2 DWORD
Informations_Messages_OS			MSG <?>				;; 5 Dwords + 2 Words


.CODE
;
; Macros
;

;;
;;
;;
;invoke9x MACRO _parametres_:VARARG
;	push ebx
;	push esi
;	push edi
;
;	invoke _parametres_
;
;	pop edi
;	pop esi
;	pop ebx
;ENDM


.CODE
;
; les procdures gnriques utilises
;
INCLUDE SomeProcs.asm


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Procdures spcifiquement cres pour le test Sprite
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


ALIGN 16
;
; gnrateur des sprites de fond
;
GenererSprites PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
;
		mov ebp,Nombre_Sprites						;; placer le nombre de sprite dans le compteur de boucle (ou du moins le registre qui va nous servir de compteur)
Label01:	mov ebx,Hauteur_Ecran_Travail/2				;; ) gnrer un nombre alatoire
		call GenererNombreAleatoire					;; )
		mov ecx,eax								;; copier le nombre alatoire obtenu dans ecx
		mov ebx,Largeur_Ecran_Travail					;; ) gnrer un nombre alatoire
		call GenererNombreAleatoire					;; )
		mov ebx,ecx								;; placer la hauteur alatoire obtenue dans ebx
		add ebx,Hauteur_Ecran_Travail/2				;; et lui ajouter la moitie de la hauteur cran
		mov esi,OFFSET Tampon_Sprite_01				;; placer l'adresse de la structure _Informations_Sprite_ dans esi
		mov edi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse de la structure _Bloc_Memoire_Ecran_ dans edi
		call AfficherSprite_Centre					;; et afficher le sprite
		dec ebp									;; dcrmenter le compteur de boucle
		jnz Label01								;; tant que c'est diffrent de 0, aller Label01

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
GenererSprites endp


ALIGN 16
;
; procdure d'valuation du temps coul (sert pour les images secondes, et pour les alternances titres)
;
EvaluationTemps PROC HWndc:DWORD,uMsg2:DWORD,Evenement_Periodique:DWORD,dwtime:DWORD

		cmp Evenement_Periodique,1					;; comparer evnement priodique  1
		jne Label1								;; si c'est diffrent, aller Label1
		pushad									;; sinon, empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; pour les images :
		mov eax,Compteur_Des_images					;; placer le Compteur_Des_images (nombre d'images obtenues) dans eax
		mov esi,OFFSET Chaine_Nombre_Images_Seconde		;; placer l'adresse qui doit contenir la chane du nombre dans esi
		call ConvertirValeurEnChaineDecimale			;; et convertir la valeur en chane dcimale
		mov Compteur_Des_images,0					;; effacer Compteur_Des_images
		mov eax,Tampon_Sprite_02._Niveau_Transparence_	;; placer le niveau de transparence (format 0,A,A,A) dans eax
		and eax,0000000FFh							;; ne conserver que le dernier octets
		mov esi,OFFSET Chaine_Nombre_Niveau_Transparence	;; placer l'adresse qui doit contenir la chane du nombre dans esi
		call ConvertirValeurEnChaineDecimale			;; et convertir la valeur en chane dcimale
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label1:
	ret
EvaluationTemps ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Processus principal -> les effets 2D de l'intro
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ProcessusPrincipal PROC

;
; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.
;
		call InitialiserNombresAleatoires				;;  effectuer au moins une fois


;
; allouer les espaces mmoire
;

; obtenir une instance mmoire
		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure _Informations_Memoire_ dans esi
		call CreerInstanceMemoire					;; et crer l'instance
; allouer un espace mmoire pour notre tampon ecran travail
		mov eax,Largeur_Ecran_Travail					;; dfinir la largeur
		mov ebx,Hauteur_Ecran_Travail+2				;; et la hauteur. ici, on ajoute 2 (une ligne au dessus et une ligne en dessous)
;		mov esi,OFFSET Instance_Memoire
		mov edi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse de la structure _Bloc_Memoire_Ecran_ dans edi
		call CreerEcran							;; et crer l'cran
		mov eax,Tampon_Ecran_Travail._Pointeur_			;; ) ici on ajoute une ligne (un dcalage ncessaire pour les effets blur)
		add eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; )
		mov Tampon_Ecran_Travail._Pointeur_,eax			;; )
		mov eax,Tampon_Ecran_Travail._Hauteur_Ecran_		;;	) ici on enleve les 2 lignes qu'on avait rajout pour avoir une hauteur valide
		sub eax,2									;;	)
		mov Tampon_Ecran_Travail._Hauteur_Ecran_,eax		;;	)
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; placer la taille  effacer dans eax
		sub eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; ) enlever les 2 lignes (a cause des 2 lignes ajoutes) (c'est ncessaire pour eviter un crash en sortie d'app)
		sub eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; )
		mov Tampon_Ecran_Travail._Taille_Du_Bloc_,eax	;; )
; tester s'il y a un redimenssionnement  effectuer
		cmp Tampon_Ecran_Travail._Largeur_Ecran_,Largeur_Ecran_Final	;; comparer la largeur  celle de l'cran final
		jne DefinirTemoinRedimensionnement				;; si il y a une diffrence, aller DefinirTemoinRedimensionnement
		cmp Tampon_Ecran_Travail._Hauteur_Ecran_,Hauteur_Ecran_Final	;; comparer la hauteur  celle de l'cran final
		jne DefinirTemoinRedimensionnement				;; si il y a une diffrence, aller DefinirTemoinRedimensionnement
		mov Temoin_Redimensionnement,0				;; sinon, c'est qu'il n'y a pas de redimensionnement  faire
		jmp FinDefinirTemoinRedimensionnement			;; aller FinDefinirTemoinRedimensionnement
DefinirTemoinRedimensionnement:
; allouer un espace mmoire pour notre tampon ecran final
		mov eax,Largeur_Ecran_Final					;; ) crer l'cran final (si c'est ncessaire)
		mov ebx,Hauteur_Ecran_Final					;; )
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call CreerEcran							;; )
		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;; placer la largeur de l'ecran travail dans eax
		shl eax,1									;; multiplier cette largeur par 2
		cmp eax,Tampon_Ecran_Final._Largeur_Ecran_		;; on compare le rsultat  la largeur de l'cran final
		jne DefinirTemoinRedimensionnement2			;; si c'est diffrent, aller DefinirTemoinRedimensionnement2
		mov eax,Tampon_Ecran_Travail._Hauteur_Ecran_		;; placer la hauteur de l'ecran travail dans eax
		shl eax,1									;; multiplier cette hauteur par 2
		cmp eax,Tampon_Ecran_Final._Hauteur_Ecran_		;; on compare le rsultat  la hauteur de l'cran final
		jne DefinirTemoinRedimensionnement2			;; si c'est diffrent, aller DefinirTemoinRedimensionnement2
		mov Temoin_Redimensionnement,1				;; sinon, il y aura un redimensionnement *2
		jmp FinDefinirTemoinRedimensionnement			;; aller FinDefinirTemoinRedimensionnement

DefinirTemoinRedimensionnement2:
; dfinir la table de redimensionnement (la mmoire est alloue avec)
		mov eax,Tampon_Ecran_Final._Largeur_Ecran_		;; ) dfinir la table de redimensionnement (pour les cas o le redimensionnement est diffrent de *2)
		mov ebx,Tampon_Ecran_Final._Hauteur_Ecran_		;; )
		mov ecx,Tampon_Ecran_Travail._Largeur_Ecran_		;; )
		mov edx,Tampon_Ecran_Travail._Hauteur_Ecran_		;; )
		mov edi,OFFSET Tampon_Table_Redimensionnement	;; )
		call DefinirTableDeRedimensionnement			;; )
		mov Temoin_Redimensionnement,2				;; il y aura un redimensionnement autre que *2
FinDefinirTemoinRedimensionnement:


;
; initialiser le/s sprite/s utilis/s
;

; pour le sprite 1
		mov edx,OFFSET Sprite01						;; placer l'adresse des donnes du sprite dans edx
		mov esi,OFFSET Tampon_Sprite_01				;; placer l'adresse de la structure _Informations_Sprite_ dans esi
		mov edi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse de la structure _Bloc_Memoire_Ecran_ dans edi
		call InitialiserSprite						;; et initialiser le sprite
; pour le sprite 2
		mov edx,OFFSET Sprite02						;; placer l'adresse des donnes du sprite dans edx
		mov esi,OFFSET Tampon_Sprite_02				;; placer l'adresse de la structure _Informations_Sprite_ dans esi
;		mov edi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse de la structure _Bloc_Memoire_Ecran_ dans edi
		call InitialiserSprite						;; et initialiser le sprite


;
; centrer notre pointeur pour le sprite
;
		mov eax,Largeur_Ecran_Final/2					;; ) placer le centre X dans Position_Pointeur_Ecran.x
		add eax,Position_Ecran_X						;; )
		mov Position_Pointeur_Ecran.x,eax				;; )
		mov eax,Hauteur_Ecran_Final/2					;; ) placer le centre Y dans Position_Pointeur_Ecran.y
		add eax,Position_Ecran_Y						;; )
		mov Position_Pointeur_Ecran.y,eax				;; )
		invoke SetCursorPos,Position_Pointeur_Ecran.x,Position_Pointeur_Ecran.y	;; sinon, placer le curseur au centre de l'cran OS (ce qui nous permet de toujours obtenir le mouvement de la souris)


;
; dbut de la boucle qui sera le processus
;
DebutBoucleProcessus:

;
; on regarde si on doit effacer l'cran
;
		cmp Temoin_Effet_Fondu,1						;; l'effet blur est activ ?
		je Label03								;; si c'est le cas, aller Label03
; s'il n'y a pas d'effet  appliquer, on efface le tampon rserv pour l'cran
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; placer la taille  effacer dans eax
		mov edi,Tampon_Ecran_Travail._Pointeur_			;; placer le pointeur de la zone  effacer dans esi
		call Mmx_EffacerBlocMemoire					;; effacer le tout
Label03:

		call GenererSprites							;; afficher les sprites de fond

;
; ensuite on regarde si on doit appliquer l'effet blur
;
		cmp Temoin_Effet_Fondu,0						;; l'effet blur est inactiv ?
		je Label04								;; si c'est le cas, aller Label04
; s'il n'y a un effet  appliquer, on l'applique
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) appliquer un effet fondu (blur) ascendant
		call Mmx_EffetFonduAscendant					;; )
Label04:


;
; dfinir la position X et Y de la chaine graphique
;
		mov eax,Position_Chaine_X					;; ) definir la position X
		cmp Temoin_Sens_Deplacement_Chaine_X,0			;; )
		jne DeplacementChaineXNegatif					;; )
		cmp eax,Largeur_Ecran_Travail					;; )
		jle IncrementerDeplacementChaineX				;; )
		xor Temoin_Sens_Deplacement_Chaine_X,1			;; )
IncrementerDeplacementChaineX:
		add eax,2									;; )
		jmp DeplacementChaineX						;; )
DeplacementChaineXNegatif:
		cmp eax,0									;; )
		jge DecrementerDeplacementChaineX				;; )
		xor Temoin_Sens_Deplacement_Chaine_X,1			;; )
DecrementerDeplacementChaineX:
		sub eax,2									;; )
DeplacementChaineX:
		mov Position_Chaine_X,eax					;; )

		mov ebx,Position_Chaine_Y					;;	) dfinir la position Y
		cmp Temoin_Sens_Deplacement_Chaine_Y,0			;;	)
		jne DeplacementChaineYNegatif					;;	)
		cmp ebx,Hauteur_Ecran_Travail					;;	)
		jle IncrementerDeplacementChaineY				;;	)
		xor Temoin_Sens_Deplacement_Chaine_Y,1			;;	)
IncrementerDeplacementChaineY:
		add ebx,2									;;	)
		jmp DeplacementChaineY						;;	)
DeplacementChaineYNegatif:
		cmp ebx,0									;;	)
		jge DecrementerDeplacementChaineY				;;	)
		xor Temoin_Sens_Deplacement_Chaine_Y,1			;;	)
DecrementerDeplacementChaineY:
		sub ebx,2									;;	)
DeplacementChaineY:
		mov Position_Chaine_Y,ebx					;;	)


;
; afficher la chaine graphique indiquant le nombre d'images par secondes
;
		cmp Temoin_Chaine,0							;; sinon, on compare Temoin_Chaine  0
		je EviterAfficherChaine						;; si c'est gal, aller EviterAfficherChaine
; ici, on dfini la couleur du texte  afficher dans l'cran
		mov eax,0FFFFFF1Fh							;; placer la couleur de la police dans eax
		mov ebx,07FFF1F1Fh							;; placer la couleur de fond dans ebx
		call DefinirCouleursChaine					;; (mettre les variables  jour)

; ici on affiche la chaine
		mov eax,Position_Chaine_X					;; position X (en pixels)
		mov ebx,Position_Chaine_Y					;; position Y (en pixels)
		mov edx,OFFSET Police_Xx20					;; placer l'adresse de la police utilise dans edx
		mov esi,OFFSET Chaine_Images_Seconde			;; placer l'adresse de la chaine  afficher dans esi
		mov edi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse du Tampon_Ecran_Travail dans edi
		call Mmx_AfficherChaine_Centree_Alpha			;; afficher la chaine
EviterAfficherChaine:


;
; afficher le sprite dirig par la souris
;
		cmp Temoin_Sprite,0							;; sinon, on compare Temoin_Sprite  0
		je EviterAfficherSprite						;; si c'est gal, aller EviterAfficherSprite
		mov eax,Position_Souris_X					;; ) definir la position et dessiner le sprite que l'on dirige avec la souris
		mov ebx,Position_Souris_Y					;; )
		mov edx,Tampon_Sprite_02._Niveau_Transparence_	;; )
		mov esi,OFFSET Tampon_Sprite_02				;; )
		mov edi,OFFSET Tampon_Ecran_Travail			;; )
		call Mmx_AfficherSprite_Centre_Alpha_Turbo		;; )
EviterAfficherSprite:


;
; afficher le niveau de transparence
;
		cmp Temoin_Statistiques,0					;; on compare Temoin_Statistiques  0
		je FinAffichageChaines						;; si c'est gal (rien  afficher), aller FinAffichageChaines
; ici, on dfini la couleur du texte  afficher dans l'cran
		mov eax,0FFFFFF1Fh							;; ) dfinir les couleurs police + fond
		mov ebx,0FF000000h							;; )
		call DefinirCouleursChaine					;; )

; ici on affiche la chaine
		xor eax,eax								;; position X (en pixels)
		xor ebx,ebx								;; position Y (en pixels)
		mov edx,OFFSET Police_Xx16					;; adresse de la police utilise
		mov esi,OFFSET Chaine_Niveau_Transparence		;; adresse de la chane  afficher
		mov edi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse du Tampon_Ecran_Travail dans edi
		call Mmx_AfficherChaine_Alpha					;; afficher cette chane  la position spcifie
FinAffichageChaines:


;
; redimenssionner l'cran (uniquement si ca doit tre fait)
;
		cmp Temoin_Redimensionnement,2				;; est-ce un redimensionnement autre que *2 ?
		je Redimensionnement						;; si c'est le cas, aller Redimensionnement
		cmp Temoin_Redimensionnement,1				;; est-ce un redimensionnement *2 ?
		je Redimensionnement2						;; si c'est le cas, aller Redimensionnement2
		invoke SetDIBitsToDevice,Pointeur_DC_Ecran,NULL,NULL,Tampon_Ecran_Travail._Largeur_Ecran_,Tampon_Ecran_Travail._Hauteur_Ecran_,NULL,NULL,NULL,Tampon_Ecran_Travail._Hauteur_Ecran_,Tampon_Ecran_Travail._Pointeur_,ADDR Informations_Bitmap,DIB_RGB_COLORS
		jmp FinRedimensionnement						;; aller FinRedimensionnement
Redimensionnement:
		mov eax,OFFSET Tampon_Table_Redimensionnement	;; ) redimensionnement vers l'cran final
		mov esi,Tampon_Ecran_Travail._Pointeur_			;; )
		mov edi,Tampon_Ecran_Final._Pointeur_			;; )
		call Redimensionner							;; )
		jmp Redimensionnement3						;; aller Redimensionnement3
Redimensionnement2:
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) redimensionnement vers l'cran final en *2
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call Mmx_AgrandirX2_RemplissageFondu			;; )
Redimensionnement3:
		invoke SetDIBitsToDevice,Pointeur_DC_Ecran,NULL,NULL,Tampon_Ecran_Final._Largeur_Ecran_,Tampon_Ecran_Final._Hauteur_Ecran_,NULL,NULL,NULL,Tampon_Ecran_Final._Hauteur_Ecran_,Tampon_Ecran_Final._Pointeur_,ADDR Informations_Bitmap,DIB_RGB_COLORS
FinRedimensionnement:


;
; fin de la boucle
;
		inc Compteur_Des_images						;; une image de plus  t faite, on incrmente donc notre compteur
		cmp Temoin_Poursuite_Processus,0				;; comparer Temoin_Poursuite_Processus  0
		jne DebutBoucleProcessus						;; tant que Temoin_Poursuite_Processus est diffrent de 0, aller DebutBoucleProcessus


;
; librer les espaces mmoire
;
		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de l'instance mmoire dans esi
		cmp Temoin_Redimensionnement,0				;; on teste s'il y a eu un redimensionnement
		je LibererMemoireEcrans2						;; s'il n'y a pas de redimensionnement, aller LibererMemoireEcrans2
		cmp Temoin_Redimensionnement,1				;; on teste s'il y a eu un redimensionnement *2
		je LibererMemoireEcrans						;; s'il n'y a pas de redimensionnement, aller LibererMemoireEcrans
		mov edi,OFFSET Tampon_Table_Redimensionnement	;; ) supprimer l'espace mmoire pour la table de redimensionnement
		call SupprimerTableDeRedimensionnement			;; )
LibererMemoireEcrans:
		mov edi,OFFSET Tampon_Ecran_Final				;; ) supprimer l'espace mmoire pour l'ecran final
		call SupprimerEcran							;; )
LibererMemoireEcrans2:
		mov edi,OFFSET Tampon_Ecran_Travail			;; ) supprimer l'espace mmoire pour l'ecran travail
		call SupprimerEcran							;; )
; supprimer l'intance mmoire
;		mov esi,OFFSET Instance_Memoire
		call SupprimerInstanceMemoire					;; supprimer l'instance obtenue par HeapCreate


;
; terminer le processus
;
		mov Temoin_Poursuite_Processus,-1				;; processus dfinitivement clos

;	ret											;; ATTENTION !!!  ne pas activer pour un processus
ProcessusPrincipal ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Point d'entre du programme
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Programme:

;
ProgrammePrincipal PROC

; on fixe la priorit de notre application
;		invoke GetCurrentProcess						;; ) fixer la priorit de notre application  haute
;		invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS	;; )
; obtenir le pointeur de la ligne de commande
		invoke GetCommandLine					;; obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_Commandes,eax				;; et sauvegarder ce pointeur dans Pointeur_Ligne_Commandes
		invoke GetModuleHandle,NULL				;; obtenir une instance de l'application
		mov Instance_Application,eax					;; et sauvegarder le pointeur dans Instance_Application
		mov Informations_Fenetre.hInstance,eax			;; pointeur de l'instance pour la fenetre en cours
; initialiser les boites de dialogue
		invoke GetModuleHandle,0					;; fourni l'instance handle
		mov Instance_Boite_Dialogue,eax				;; sauver l'instance
; faire disparaitre le pointeur cran
		invoke ShowCursor,FALSE					;; faire disparaitre le pointeur cran


;
; centrer la position de notre cran (pour le cas o celui-ci est infrieur  l'cran OS)
;
		invoke GetSystemMetrics,SM_CXSCREEN			;; obtenir la taille x de l'ecran os (en pixels)
		sub eax,Largeur_Ecran_Final					;; soustraire la largeur de notre ecran final
		sar eax,1									;; diviser ensuite ce resultat par 2
		mov Position_Ecran_X,eax						;; et placer le rsultat dans Position_Ecran_X
		invoke GetSystemMetrics,SM_CYSCREEN			;; obtenir la taille y de l'ecran os (toujours en pixels)
		sub eax,Hauteur_Ecran_Final					;; soustraire la hauteur de notre cran final
		sar eax,1									;; diviser ensuite ce resultat par 2
		mov Position_Ecran_Y,eax						;; et placer le rsultat dans Position_Ecran_Y


;
; remplir la structure BITMAPINFO avec les variables reuises
;
		mov Informations_Bitmap.biSize,SIZEOF BITMAPINFOHEADER	;; taille de la structure BITMAPINFOHEADER
		mov Informations_Bitmap.biWidth,Largeur_Ecran_Final	;; la largeur
		mov Informations_Bitmap.biHeight,-Hauteur_Ecran_Final	;; la hauteur (ngative, pour que la premire ligne soit celle du haut, et pas celle du bas)
		mov Informations_Bitmap.biPlanes,1				;;
		mov Informations_Bitmap.biBitCount,32			;; pour des couleurs 32 bits
		mov Informations_Bitmap.biCompression,BI_RGB		;; (BI_RGB=pas de compression)


;
; remplir la structure WNDCLASSEX avec les variables requises, et cration de l'cran
;
		invoke LoadIcon,Instance_Application,500		;; pointeur sur l'icone (500 = ID de l'icne)
		mov Informations_Fenetre.hIcon,eax				;; sauver le pointeur
		invoke LoadCursor,NULL,IDC_ARROW
		mov Informations_Fenetre.hCursor,eax
; remplir le reste de la structure WNDCLASSEX avec les variables requises
		mov Informations_Fenetre.cbSize,SIZEOF WNDCLASSEX
		mov Informations_Fenetre.style,CS_BYTEALIGNCLIENT or CS_NOCLOSE
		mov Informations_Fenetre.lpfnWndProc,OFFSET GestionnaireMessages
		mov Informations_Fenetre.cbClsExtra,NULL
		mov Informations_Fenetre.cbWndExtra,NULL
		mov Informations_Fenetre.hbrBackground,COLOR_WINDOWTEXT
		mov Informations_Fenetre.lpszMenuName,NULL
		mov Informations_Fenetre.lpszClassName,OFFSET Chaine_Type_Fenetre
		mov Informations_Fenetre.hIconSm,0
		invoke RegisterClassEx,ADDR Informations_Fenetre
; maintenant que tous les parametres sont dfinis, on cr l'cran
		invoke CreateWindowEx,WS_EX_LEFT,ADDR Chaine_Type_Fenetre,ADDR Chaine_Titre_Fenetre,WS_POPUP,Position_Ecran_X,Position_Ecran_Y,Largeur_Ecran_Final,Hauteur_Ecran_Final,NULL,NULL,Instance_Application,NULL
		mov Pointeur_Fenetre,eax


;
; ici, on va tester le microprocesseur pour savoir si le minimum requis est disponible (on l'a pas fait avant parcequ'il fallait Pointeur_Fenetre)
;
		call DefinirAptitudesDuProcesseur
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
		mov eax,Temoins_Aptitudes_Du_MicroProcesseur		;; copier les tmoins obtenus dans eax
;		mov edx,000000000001b						;; cpuid
;		mov edx,000000000011b						;; cpuid + fpu
;		mov edx,000000010011b						;; cpuid + fpu + cmov
;		mov edx,000001010011b						;; cpuid + fpu + cmov + mmx
		mov edx,000101010011b						;; cpuid + fpu + cmov + mmx + sse
;		mov edx,001101010011b						;; cpuid + fpu + cmov + mmx + sse + sse2
;		mov edx,101101010011b						;; cpuid + fpu + cmov + mmx + sse + sse2 + sse3
		and eax,edx								;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx								;; et on s'asure qu'ils sont tous l
		je MicroprocesseurSuffisant					;; si c'est gal (le microprocesseur a le minimum requis), aller MicroprocesseurSuffisant
; sinon on va afficher la boite de dialogue en consquence
		invoke ShowCursor,TRUE					;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boite_Dialogue,ADDR Chaine_Boite_Dialogue_Insuffisant,0,ADDR GestionnaireMessagesBoiteDialogue,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
MicroprocesseurBoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,Vide,Vide,Vide	;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,Pointeur_Fenetre,NULL,NULL	;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL								;; comparer eax  zro
		je MicroprocesseurInsuffisant					;; si c'est gal  0 (pas de message), aller MicroprocesseurInsuffisant
;		invoke TranslateMessage,ADDR Informations_Messages_OS	;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS	;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessages au moment voulu)
		jmp MicroprocesseurBoucleMessages				;; aller MicroprocesseurBoucleMessages (pour aller lire le message suivant)
MicroprocesseurSuffisant:


;
; sinon, le minimum requis est prsent, alors on cr un pointeur pour le device context
;
		invoke GetDC,Pointeur_Fenetre				;; obtenir le device context de notre fenetre/cran
		mov Pointeur_DC_Ecran,eax					;; sauvegarder le pointeur obtenu


;
; dfinir et lancer le processus principal
;
		invoke CreateThread,NULL,Taille_Pile_Processus_Principal*1024,ADDR ProcessusPrincipal,Pointeur_Fenetre,NULL,ADDR Pointeur_Processus_Principal
		mov Pointeur_Processus_Principal,eax			;; sauvegarder le pointeur obtenu
		invoke SetThreadPriority,Pointeur_Processus_Principal,THREAD_PRIORITY_NORMAL	;; laisser la priorit du processus  la normale THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		mov Temoin_Poursuite_Processus,1				;; le processus est maintenant actif
		invoke ShowWindow,Pointeur_Fenetre,SW_SHOWNORMAL
		invoke UpdateWindow,Pointeur_Fenetre
		invoke SetTimer,Pointeur_Fenetre,1,1000,OFFSET EvaluationTemps


;

; boucle a effectuer tant que le message PostQuitMessage n'a pas t envoy
;
BoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL	;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,Pointeur_Fenetre,NULL,NULL	;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL								;; comparer eax  zro
		je FinBoucleMessages						;; si c'est gal  0 (pas de message), aller FinBoucleMessages
		invoke TranslateMessage,ADDR Informations_Messages_OS			;; sinon, traduire
		invoke DispatchMessage,ADDR Informations_Messages_OS			;; et dispatcher
		jmp BoucleMessages							;; aller BoucleMessages (pour aller lire le message suivant)
FinBoucleMessages:


;
; par ici la sortie...
;
		invoke SetThreadPriority,Pointeur_Processus_Principal,THREAD_PRIORITY_NORMAL	;; baisser la priorit du processus... THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		invoke TerminateThread,Pointeur_Processus_Principal,0
		invoke DeleteDC,Pointeur_DC_Ecran				;; supprimer le device context
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
; on restaure la priorit
MicroprocesseurInsuffisant:
;		invoke GetCurrentProcess						;; ) remettre la priorit du programme  la normale
;		invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS	;; )
		invoke ExitProcess,Informations_Messages_OS.wParam			;; sortie de l'application

ProgrammePrincipal ENDP


ALIGN 16
;
; Traitement des messages windows
;
GestionnaireMessages PROC HWndGM:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD
;LOCAL DessinEcran :PAINTSTRUCT

		cmp Temoin_Poursuite_Processus,-1				;; le processus est arrt ?
		jne GMPasFinApplication						;; si ce n'est pas le cas, aller GMPasFinApplication
		invoke PostQuitMessage,NULL					;; sinon, poster le message de sortie
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMPasFinApplication:
		mov eax,Message							;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

; initialisation de la fentre
;		cmp eax,WM_CREATE
;		jne GMFinInitialisation						;; sinon, aller GMFinInitialisation
;
;	ret											;; retourner
;ALIGN 16
;GMFinInitialisation:

;; dessin de la fentre
;		cmp eax,WM_PAINT
;		jne GMFinMiseAJourEcran						;; sinon, aller GMFinMiseAJourEcran
;
;	ret											;; retourner
;ALIGN 16
;GMFinMiseAJourEcran:

; fermeture de l'application ?
		cmp eax,WM_CLOSE
		jne GMFinFermeture							;; sinon, aller GMFinFermeture
		mov Temoin_Poursuite_Processus,0
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMFinFermeture:

; fin du processus principal
		cmp eax,WM_DESTROY
		jne GMFinProcessusTermine					;; sinon, aller GMFinProcessusTermine:
		mov Temoin_Poursuite_Processus,0
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMFinProcessusTermine:


;
; ici, les messages concernant les touches prsses
;
		cmp eax,WM_KEYDOWN
		jne GMFinTouchePressee						;; sinon, aller GMFinTouchePressee
		mov eax,WParam

; Quitter ?
		cmp eax,VK_ESCAPE							;; Quitter ?
		jne GMFinToucheQuitter						;; sinon, aller GMFinToucheQuitter
; faire rapparaitre le pointeur cran
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boite_Dialogue,ADDR Chaine_Boite_Dialogue_Quitter,0,ADDR GestionnaireMessagesBoiteDialogue,0
; faire disparaitre le pointeur cran
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
	ret											;; retourner
ALIGN 16
GMFinToucheQuitter:
;; F1 ?
;		cmp eax,VK_F1
;		jne GMFinToucheF1Pressee						;; sinon, aller GMFinToucheF1Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF1Pressee:
;; F2 ?
;		cmp eax,VK_F2
;		jne GMFinToucheF2Pressee						;; sinon, aller GMFinToucheF2Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF2Pressee:
;; F3 ?
;		cmp eax,VK_F3
;		jne GMFinToucheF3Pressee						;; sinon, aller GMFinToucheF3Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF3Pressee:
;; F4 ?
;		cmp eax,VK_F4
;		jne GMFinToucheF4Pressee						;; sinon, aller GMFinToucheF4Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF4Pressee:
;; F5 ?
;		cmp eax,VK_F5
;		jne GMFinToucheF5Pressee						;; sinon, aller GMFinToucheF5Pressee
;
;	ret
;ALIGN 16
;GMFinToucheF5Pressee:
;; F6 ?
;		cmp eax,VK_F6
;		jne GMFinToucheF6Pressee						;; sinon, aller GMFinToucheF6Pressee
;
;	ret
;ALIGN 16
;GMFinToucheF6Pressee:
;; F7 ?
;		cmp eax,VK_F7
;		jne GMFinToucheF7Pressee						;; sinon, aller GMFinToucheF7Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF7Pressee:
;; F8 ?
;		cmp eax,VK_F8
;		jne GMFinToucheF8Pressee						;; sinon, aller GMFinToucheF8Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF8Pressee:
;; F9 ?
;		cmp eax,VK_F9
;		jne GMFinToucheF9Pressee						;; sinon, aller GMFinToucheF9Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF9Pressee:
;; F11 ?
;		cmp eax,VK_F11
;		jne GMFinToucheF11Pressee					;; sinon, aller GMFinToucheF11Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF11Pressee:
;; F12 ?
;		cmp eax,VK_F12
;		jne GMFinToucheF12Pressee					;; sinon, aller GMFinToucheF12Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheF12Pressee:
; gauche ?
		cmp eax,VK_LEFT
		jne GMFinToucheGauchePressee					;; sinon, aller GMFinToucheGauchePressee

	ret											;; retourner
ALIGN 16
GMFinToucheGauchePressee:
; droite ?
		cmp eax,VK_RIGHT
		jne GMFinToucheDroitePressee					;; sinon, aller GMFinToucheDroitePressee

	ret											;; retourner
ALIGN 16
GMFinToucheDroitePressee:
; haut ?
		cmp eax,VK_UP
		jne GMFinToucheHautPressee					;; sinon, aller GMFinToucheHautPressee

	ret											;; retourner
ALIGN 16
GMFinToucheHautPressee:
; bas ?
		cmp eax,VK_DOWN
		jne GMFinToucheBasPressee					;; sinon, aller GMFinToucheBasPressee

	ret											;; retourner
ALIGN 16
GMFinToucheBasPressee:
; b ?
		cmp eax,VK_B
		jne GMFinToucheBPressee						;; sinon, aller GMFinToucheBPressee
		xor Temoin_Effet_Fondu,1
	ret											;; retourner
ALIGN 16
GMFinToucheBPressee:
; c ?
		cmp eax,VK_C
		jne GMFinToucheCPressee						;; sinon, aller GMFinToucheCPressee
		xor Temoin_Chaine,1
	ret											;; retourner
ALIGN 16
GMFinToucheCPressee:
; i ?
		cmp eax,VK_I
		jne GMFinToucheIPressee						;; sinon, aller GMFinToucheIPressee
		xor Temoin_Statistiques,1
	ret											;; retourner
ALIGN 16
GMFinToucheIPressee:
; s ?
		cmp eax,VK_S
		jne GMFinToucheSPressee						;; sinon, aller GMFinToucheSPressee
		xor Temoin_Sprite,1
	ret											;; retourner
ALIGN 16
GMFinToucheSPressee:
; prcdent ?
		cmp eax,VK_PGUP							;; page prcedente ?
		jne GMFinTouchePrecedentPressee				;; sinon, aller GMFinTouchePrecedentPressee
		mov esi,OFFSET Tampon_Sprite_02				;; lire l'adresse de la structure _Informations_Sprite_
		call DecrementerSpriteAlphas					;; et modifier l'alpha des pixels non-transparent en consquence
GMEviterAttenuerTransparence:
	ret											;; retourner
ALIGN 16
GMFinTouchePrecedentPressee:
; suivant ?
		cmp eax,VK_PGDN							;; page suivante ?
		jne GMFinToucheSuivantPressee					;; sinon, aller GMFinToucheSuivantPressee
		mov esi,OFFSET Tampon_Sprite_02				;; lire l'adresse de la structure _Informations_Sprite_
		call IncrementerSpriteAlphas					;; et modifier l'alpha des pixels non-transparent en consquence
GMEviterAffirmerTransparence:
	ret											;; retourner
ALIGN 16
GMFinToucheSuivantPressee:


	ret											;; retourner
ALIGN 16
GMFinTouchePressee:
;; bouton souris gauche ?
;		cmp eax,WM_RBUTTONDOWN 
;		jne GMFinBoutonGaucheSourisPresse				;; sinon, aller GMFinBoutonGaucheSourisPresse
;
;	ret											;; retourner
;ALIGN 16
;GMFinBoutonGaucheSourisPresse:
;; bouton souris droit ?
;		cmp eax,WM_RBUTTONDOWN 
;		jne GMFinBoutonDroitSourisPresse				;; sinon, aller GMFinBoutonDroitSourisPresse
;
;	ret											;; retourner
;ALIGN 16
;GMFinBoutonDroitSourisPresse:
; mouvement de la souris ?
		cmp eax,WM_MOUSEMOVE
		jne GMFinMouvementSouris						;; sinon, aller GMFinMouvementSouris
		mov eax,LParam
		mov edx,eax
		shr edx,16
		and eax,00000FFFFh
		sub eax,Largeur_Ecran_Travail/2
		sub edx,Hauteur_Ecran_Travail/2
		mov Position_Souris_X,eax
		mov Position_Souris_Y,edx
		mov eax,WParam
; bouton gauche ?
		cmp eax,MK_LBUTTON
		jne GMFinBoutonGaucheSouris					;; sinon, aller GMFinBoutonGaucheSouris

	ret											;; retourner
ALIGN 16
GMFinBoutonGaucheSouris:
; bouton droit ?
		cmp eax,MK_RBUTTON
		jne GMFinBoutonDroitSouris					;; sinon, aller GMFinBoutonDroitSouris

	ret											;; retourner
ALIGN 16
GMFinBoutonDroitSouris:
	

	ret											;; retourner
ALIGN 16
GMFinMouvementSouris:


;
; ici, les messages concernant les touches relaches
;
		cmp eax,WM_KEYUP
		jne GMFinToucheRelachee
		mov eax,WParam

; gauche ?
		cmp eax,VK_LEFT
		jne GMFinToucheGaucheRelachee					;; sinon, aller GMFinToucheGaucheRelachee

	ret											;; retourner
ALIGN 16
GMFinToucheGaucheRelachee:
; droite ?
		cmp eax,VK_RIGHT
		jne GMFinToucheDroiteRelachee					;; sinon, aller GMFinToucheDroiteRelachee

	ret											;; retourner
ALIGN 16
GMFinToucheDroiteRelachee:
; haut ?
		cmp eax,VK_UP
		jne GMFinToucheHautRelachee					;; sinon, aller GMFinToucheHautRelachee

	ret											;; retourner
ALIGN 16
GMFinToucheHautRelachee:
; bas ?
		cmp eax,VK_DOWN
		jne GMFinToucheBasRelachee					;; sinon, aller GMFinToucheBasRelachee

	ret											;; retourner
ALIGN 16
GMFinToucheBasRelachee:


	ret											;; retourner
ALIGN 16
GMFinToucheRelachee:

;
; on finit avec le traitement par dfaut
;
		invoke DefWindowProc,HWndGM,Message,WParam,LParam
	ret
GestionnaireMessages ENDP


ALIGN 16
;
; gestionnaire des messages par boites de dialogue
;
GestionnaireMessagesBoiteDialogue PROC HWndDlg:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message							;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)


		cmp eax,WM_COMMAND
		jne GMBDFinCommandes
		mov eax,WParam								;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)


;
; boite de dialogue pour microprocesseur insuffisant
;

; Il est temps d'en changer...
		cmp eax,1002								;; Hum... oui est cliqu ?
		jne GMBDPasTempsChangerMicro					;; si c'est diffrent, aller GMBDPasTempsChangerMicro
		invoke EndDialog,HWndDlg,0				;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL				;; poster le message de sortie
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMBDPasTempsChangerMicro:

;
; boite de dialogue pour quitter le programme
;

; hum... oui
		cmp eax,1012								;; Hum... oui est cliqu ?
		jne GMBDFinHumOui							;; si c'est diffrent, aller GMBDFinHumOui
		mov Temoin_Poursuite_Processus,0				;; stopper le processus en cours
		invoke EndDialog,HWndDlg,0				;; sinon, fermer la boite de dialogue
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMBDFinHumOui:

; Ah a non !
		cmp eax,1013								;; Ah a non ! est cliqu ?
		jne GMBDFinAhCaNon							;; si c'est diffrent, aller GMBDFinAhCaNon
		invoke EndDialog,HWndDlg,0				;; sinon, fermer la boite de dialogue
	ret											;; retourner
ALIGN 16
GMBDFinAhCaNon:

;
; traitement par dfaut pour les boites de dialogue
;
GMBDFinCommandes:
		xor eax,eax								;; effacer eax (ce sera le traitement par dfaut des messages)
	ret											;; retourner
GestionnaireMessagesBoiteDialogue ENDP


;
; fin du programme
;
END Programme

